;
; ╔═════════════════════════════════════════════════════════════════════════╗
; ║     This file is generated by The Interactive Disassembler (IDA)        ║
; ║     Copyright (c) 2006 by DataRescue sa/nv, <ida@datarescue.com>        ║
; ║ Licensed to: Torukh Makhto                                              ║
; ╚═════════════════════════════════════════════════════════════════════════╝
;
; Input MD5   : 6493404B2CCB1F775F02BAD3E3065B5A

; ───────────────────────────────────────────────────────────────────────────
; File Name   : DESSbk
; Format      : Binary file
; Base Address: 0000h Range: 0200h - 34D0h Loaded length: 32D0h

; Processor:        K1801VM1
; Target assembler: BK Turbo8 Cross Assembler

; ═══════════════════════════════════════════════════════════════════════════
DR$INIT   = 160010  ; п/п инициализации рабочей области драйвера дисковода
.include "inc\FDDParam.asm"

; ══ Системные ячейки МКДОС ═════════════════════════════════════════════════
MK$NAM    =    306  ; Адрес блока параметров EMT36
MK$DRIVER = 100054  ; Адрес входа "чтение/запись блока" драйвера НГМД (160004).
                    ; Может использоваться для обслуживания нестандартных устройств,
                    ; например виртуального диска).
MK$VERS   = 120004  ; Версия Системы 3.15 (100000+315.)
MK$BLK    = 120006  ; Адрес блока параметров диска
MK$DEVTEK = 120012  ; Номер текущего устройства (0)
MK$INIDRV = 120016  ; Инициализация драйвера дисковода
MK$RDDIR  = 120024  ; Чтение каталога в буфер (@#DIR)
MK$DIRFIN = 120026  ; Поиск файла в каталоге
MK$SCREEN = 120074  ; Ячейка перехвата вывода сообщений системы, адрес подпрограммы
                    ; обращения вместо EMT16. Для запрета вывода - адрес ближайшей
                    ; команды RTS PC (0)

; ══ Системные ячейки АНДОС ═════════════════════════════════════════════════
AN$DRVTAB = 120020  ; Рабочая область драйвера НГМД
AN$DRIVER = 120106  ; Адрес входа "чтение/запись блока" драйвера НГМД (160004).
                    ; Может использоваться для обслуживания нестандартных устройств,
                    ; например виртуального диска).
AN$NAMBUF = 120114  ; Буфер имени.
AN$SCREEN = 120150  ; Ячейка перехвата вывода на экран сообщений ANDOS (Значение
                    ; по умолчанию 0). При ненулевом значении этой ячейки при
                    ; выводе сообщений вместо EMT 16 выполняется вызов подпрограммы, 
                    ; адрес которой находится в этой ячейке. Для запрета вывода
                    ; на экран достаточно поместить в SCREEN адрес любого кода 207,
                    ; например 100256 . При перезапуске ANDOS ячейка SCREEN очищается.
AN$DEVICE = 120154  ; Текущее устройство (0-@:, 1-32 - A:-Z:).
AN$DEVTEK = 120155  ; Временное текущее устройство. Совпадает с DEVICE при 
                    ; запуске  операции,  изменяется при явном указании устройства в имени.
AN$VERS   = 120170  ; Версия ANDOS (для V3.1 - 100466)

AN$INIDRV = 120204  ; Инициализация работы с диском
AN$DIRFIN = 120216  ; Поиск файла в каталоге
; ═══════════════════════════════════════════════════════════════════════════

BEGIN:          jmp     Begin$1
; ── Область системных переменных ───────────────────────────────────────────
BUFFER:         .word 35000             ; Адрес буфера чтения блока
                                        ; за буфером должно быть дополнительно 4 слова из-за того,
                                        ; что выводится по 6 слов в строке вместо 8, из-за чего
                                        ; не получается точно по границе блока обрезать вывод
USR:            .word Splash            ; Адрес загрузки функции пользователя
SIZ:            .word 47040             ; Размер диска (граница поиска)
OFSADR:         .word 0                 ; Адрес смещения (Offset)
OFSBLK:         .word 0                 ; Блок смещения
BLK:            .word 0                 ; Текущий блок
KS:             .word 0                 ; Контрольная сумма блока после чтения
METADR:         .word 35000             ; Адрес метки (в буфере)
METBLK:         .word 0                 ; блок в буфере на который поставлена метка
MOD:            .word 0                 ; Модель WORD,BYTE или адрес цепочки модели
                                        ; ASCII или MACRO-11 (адрес конца цепочки
                                        ; хранится в ячейке перед ней, т.е. @#MOD-2)
MODFLG:         .byte 0                 ; Флаг типа модели: 0-WORD,  1-BYTE
                                        ;                   2-ASCII, 3-MACRO.
DEV:            .byte 0                 ; Текущее устройство
FLAG:           .byte 0                 ; Флаг курсора: 0 - курсор в поле цифр,
                                        ;               1 - курсор в поле символов
INFFLG:         .byte 0                 ; Флаг информации: 0-DEC, 1-BIN, 3-OCT.
INF:            .byte 12                ; Система счисления для вывода информации: 10. - dec, 2 - bin, 8. - oct
USRFLG:         .byte 1                 ; Флаг наличия подпрограммы пользователя
                                        ; 1 - подпрограмма отсутствует
                                        ; 0 - подпрограмма загружена
; ── Область системных вызовов ──────────────────────────────────────────────
GETNUM:         jmp     InputNumber     ; Ввод числа с клавиатуры, в понимаемых системах счисления
                                        ; Выход: R5 - число
GET:            jmp     StrToNumber     ; Парсинг числа из строки символов.
                                        ; Вход: R3 - адрес буфера строки
                                        ;       R0 - суффикс, по которому определяется система счисления
                                        ;       . - десятичное число, B - двоичное, иначе восьмеричное
                                        ; Выход: R5 - число
STROKA:         jmp     InputString     ; Редактор строки.
OCTOUT:         jmp     OutNumOct       ; Вывод восьмеричного числа из R5 на экран
                                        ; Вход: R5 - число
INOUT:          jmp     RWBlock         ; Подпрограмма чтения/записи с диска, аналог @#160004
OFF:            jmp     FinishRWOp      ; Подпрограмма остановки дисковода, подсчёт КС и вывод в служебную строку номера блока
                                        ; находящегося в буфере
TXT:            jmp     OutStrI         ; Перемещаемый вывод строки символов
EMT6R:          jmp     Inkey$          ; Опрос клавиатуры с автоповтором
EMT6:           jmp     Input$LC        ; Опрос клавиатуры, с возвращением латинского заглавного регистра.
ASSMBL:         jmp     Assemble
DISASS:         jmp     Disassemble     ; Вывод текущего дизассемблированного кода под курсором
OCTOUI:         jmp     OutNumOct$F     ; Вывод восьмеричного числа на экран через IOT
                                        ; Вход: R5 - число
CURADR:         .word 0                 ; текущий адрес в файле
PRINT:          jmp     Print$          ; Печать символьной копии экрана.

; ── Ещё системные переменные ───────────────────────────────────────────────
DRVTAB:         .word 400               ; Адрес блока параметров драйвера дисковода
                                        ; для не ANDOS систем (400)
; свои параметры для драйвера дисковода
DrvParam$:
TIMDOW:         .word 2000              ; задержка опускания головки,
TIMTRK:         .word 600               ; задержка перехода с дорожки на дорожку
TRK:            .byte 1                 ; байт дисковода 0 - 40, 1 - 80
DISK:           .byte 1                 ; байт дискеты 0 - 40, 1 - 80
SIDE:           .byte 0, 0              ; байты кол-ва сторон 0 - 2, 2 - 1

OSType:         .byte 0                 ; флаг: 0 - АНДОС !0 - МКДОС
VERSION:        .byte 271
; ── Ещё системные вызовы ───────────────────────────────────────────────────
REPLAC:         jmp     Replace$        ; Подсчёт КС блока - буфера и перезапись
                                        ; по запросу "Replace?" при несовпадении.
; И так и будет продолжаться дальше. Если в новой версии понадобится добавить
; новые переменные или вызовы, они снова будут вперемешку, для сохранения
; совместимости с уже существующими модулями DSS

; ═══════════════════════════════════════════════════════════════════════════

jmp_1144:       cmp     @#MK$VERS, #100000+210. ; Это МКДОС не ниже v210 ?
                blo     Start$              ; нет - запустим прогу
                tst     @#MK$SCREEN         ; вывод сообщений в МКДОС перехвачен?
                bne     Start$              ; да - тогда просто запустим прогу
                inc     (PC)+
MK$SCR:         .word 0                     ; флаг перехвата вывода сообщений в МКДОС
                movb    @#MK$DEVTEK, CurDev ; номер текущего привода в МКДОС
; Точка старта работы
Start$:         mov     #BEGIN, SP
                call    InitVec

NoSplash$:      call    Splash              ; Заставка, запакованная БКПаком
                mov     #401, NoSplash$     ; заставку больше не выводить
                call    CursorSwitch        ; Переключение режима индикации курсора
                clrb    FLAG                ; Флаг курсора: 0 - курсор в поле цифр,
                                            ;               1 - курсор в поле символов
                mov     BUFFER, R5          ; адрес начала буфера

InputDev$:      call    InitCursorPos
                call    GetDevName

ConfigureDev$:  clr     BLK                 ; начинаем с блока 0
                mov     DRVTAB, R3
                clr     (R3)
                call    @#DR$INIT
                mov     #DrvParam$, R1
                mov     (R1)+, D$TDOWN(R3)  ; задержка опускания головки
                mov     (R1)+, D$TSTEP(R3)  ; задержка перехода с дорожки на дорожку
                add     #D$FLGTAB, R3       ; таблица признаков, по байту на привод
                clr     (R3)                ; флаги пока очистим
                cmpb    (R1)+, (R1)+        ; наши флаги для обоих приводов совпадают?
                beq     1$                  ; да - переход
                mov     #401, (R3)          ; нет - флаги приводов - 40 дорожек.
1$:             bis     (R1)+, (R3)         ; и ещё установим доп. флаги
                movb    #-1, (R1)           ; устанавливаем признак МКДОС
                cmp     @#AN$VERS, #100000+223. ; Версия АНДОС меньше 2.23 ?
                blo     jmp_1454            ; да
                cmp     @#AN$DRVTAB+D$SECLEN, #400 ; нет, а размер сектора - 400 слов?
                bne     jmp_1454
                clrb    (R1)                ; устанавливаем признак АНДОС
                movb    DEV, @#AN$DEVTEK    ; Временное текущее устройство в АНДОС
                incb    @#AN$DEVTEK
                .addr   R1, BEEP
                mov     R1, @#AN$SCREEN     ; Ячейка перехвата вывода на экран сообщений АНДОС
                mov     @#4, Tmp$StV4
                mov     R1, @#4
                sub     #BEEP-HLTTrp2, @#4
                call    @AN$INIDRV          ; Инициализация работы с диском
                br      2$

HLTTrp2:        add     #34, SP
                sec
2$:             mov     (PC)+, @(PC)+
Tmp$StV4:      .word    1174, 4
                mov     @#AN$SCREEN, R1     ; вот так мы обнуляем ячейку 120150, чтобы бит C не затронуть.
                xor     R1, @#AN$SCREEN     ; а можно было просто mov #0 делать
                bcc     jmp_1454
                mov     DRVTAB, R3
                mov     D$FLGTAB(R3), @#AN$DRVTAB+D$FLGTAB

jmp_1454:       mov     BUFFER, R5      ; адрес начала буфера
jmp_1460:       mov     R5, -(SP)
                clr     R1
                .addr   R2, StrDESS
                call    OutStr$SL       ; Вывод текста в служебную строку
                                        ; Вход: R2 - строка
                                        ;       R1 - координата
                add     #7, R1
                mov     #'/, R0
                emt     22
                add     #7, R1
                call    OutStr$SL       ; Вывод текста в служебную строку
                                        ; Вход: R2 - строка
                                        ;       R1 - координата
                call    OutBlkNum$SL    ; Вывод в служебную строку номера блока в буфере
                mov     #400, R1        ; размер блока в словах
                tst     BLK             ; номер блока 0..32767 ?
                bpl     3$              ; да - всё в порядке
                tst     (SP)+           ; иначе - начнём с инициализации
                br      ConfigureDev$

3$:             call    RWBlkErrHandl   ; Чтение/запись блока с обработкой ошибок
                call    OFF             ; останов двигателя, подсчёт КС и вывод в служебную строку номера блока
                                        ; находящегося в буфере
                mov     (SP)+, R5
                br      DrawDump

Begin$1:        cmp     @#120446, #42116 ; Это ANDOS ?
                bne     1$                  ; Нет
                movb    @#AN$DEVICE, CurDev ; да - сохраним номер текущего привода
                decb    CurDev          ; отсчёт от нуля
1$:             jmp     jmp_1144

; ───────────────────────────────────────────────────────────────────────────
CurDev:         .byte 0                 ; номер привода
                .byte 0

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; запрос номера рабочего устройства
; Выход: R0 - номер устройства

GetDriveName:   clr     R5
                call    @#100476        ; ввод восьмеричного числа с клавиатуры (коды меньше 60
                                        ; и больше 67 не учитываются, число в R5)
                movb    R5, R0

; установка рабочего устройства и формирование его символьного имени
; Вход: R0 - номер устройства

SetDriveName:   movb    R0, DEV
                add     #'A, R0
                cmpb    R0, #'@
                blo     1$
                cmpb    R0, #177
                blos    2$
1$:             movb    #'?, R0
2$:             movb    R0, StrDriveName
                return
; End of function GetDriveName

; ───────────────────────────────────────────────────────────────────────────
                nop
                nop
                nop

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


ContinueDraw:   tst     (SP)+
DrawDump:       mov     BUFFER, R1      ; адрес начала буфера
                add     #1000, R1       ; зачищаем хвост
                clr     (R1)+
                clr     (R1)+
                clr     (R1)+
                clr     (R1)+
                mov     #11232, R0      ;Переключение режима индикации курсора, Исходная установка курсора
                emt     16
                swab    R0
                emt     16
                ; Вывод дампа на экран
                mov     #26, R3         ; 22. строки
                mov     R5, -(SP)       ; текущий адрес в буфере
                bic     #377, R5        ; выравнивание по границе полублока
                mov     R5, R2          ; для числового вида
                mov     R5, R1          ; для текстового вида
                sub     BUFFER, R5      ; получим смещение внутри буфера

1$:             mov     #40, R0
                iot
                call    OutNumOct$F     ; Вывод восьмеричного числа на экран через IOT
                                        ; Вход: R5 - число
                mov     #'), R0
                iot

                mov     #6, R4          ; 6 слов в строке
2$:             mov     #40, R0
                iot
                mov     (R2)+, R5
                call    OutNumOct$F     ; Вывод восьмеричного числа на экран через IOT
                                        ; Вход: R5 - число
                sob     R4, 2$

                mov     #14, R4         ; 12. символов в текстовом представлении
                mov     #'║, R0
                iot
3$:             movb    (R1)+, R0
                bic     #177400, R0
                call    SetSafeChr      ; Замена непечатных символов на точку
                iot
                sob     R4, 3$

                mov     #'║, R0
                iot
                mov     R2, R5
                sub     BUFFER, R5      ; адрес начала буфера
                sob     R3, 1$
                mov     #5231, R0       ; Удаление правой от курсора части строки, перевод строки
                emt     16
                swab    R0
                emt     16
                call    OutStrMacro11   ; Выводим текст-пояснение
                br      0Next$
; End of function ContinueDraw


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


jmp_2070:       call    ClearCmdLn
                call    CursorSwitch    ; Переключение режима индикации курсора

0Next$:         call    OutBlkNum$SL    ; Вывод в служебную строку номера блока в буфере
                clr     R1
                .addr   R2, StrDESS
                call    OutStr$SL       ; Вывод текста в служебную строку
                                        ; Вход: R2 - строка
                                        ;       R1 - координата
                add     #7, R1
                mov     #'/, R0
                emt     22
                add     #7, R1
                call    OutStr$SL       ; Вывод текста в служебную строку
                                        ; Вход: R2 - строка
                                        ;       R1 - координата
                add     #7, R1
                movb    INFFLG, R0      ; Режим вывода данных: 0 - dec, 1 - bin, >=2 - oct
                bne     1$
                .addr   R2, StrDecimal
                br      3$

1$:             decb    R0
                bne     2$
                .addr   R2, StrBinary
                br      3$

2$:             .addr   R2, StrOctal
3$:             call    OutStr$SL       ; Вывод текста в служебную строку
                                        ; Вход: R2 - строка
                                        ;       R1 - координата
                mov     #40, R0
4$:             cmp     R1, #77         ; очищаем остаток служебной строки
                beq     5$
                inc     R1
                emt     22
                br      4$

5$:             mov     (SP), R5        ; текущий адрес в буфере
                bic     #1, R5          ; выравниваем по слову
                mov     R5, R0
                bic     #377, R0        ; а тут выравниваем по полублоку
                ;рассчитаем координаты курсора
                clr     R2              ; номер строки
6$:             mov     #11, R1         ; позиция в числовом поле дампа
                mov     #63, R4         ; позиция в текстовом поле дампа
7$:             cmp     R5, R0          ; дошли до адреса?
                blos    8$              ; да
                tst     (R0)+           ; двигаемся на слово вперёд
                tst     (R4)+           ; на два байта в текстовом поле
                add     #7, R1          ; к следующему слову в числовом поле
                cmp     R1, #63         ; поле кончилось?
                bne     7$              ; нет - продолжаем
                inc     R2              ; переходим к следующей строке
                br      6$

8$:             mov     (SP)+, R5       ; текущий адрес в буфере
                mov     #17, R3
                bit     #1, R5          ; адрес чётный?
                beq     9$              ; да - переход
                add     #3, R1          ; нет - скорректируем позицию в числовом поле
                mov     #6, R3
                bic     #1, R5          ; выровняем по слову
9$:             emt     24
                call    CursorSwitch    ; Переключение режима индикации курсора
                tstb    FLAG            ; Флаг курсора: 0 - курсор в поле цифр,
                                        ;               1 - курсор в поле символов
                beq     jmp_2356
                call    SwitchToCharField       ; Меняем местами R1 и R4
                                        ; если R3 > 10 то прибавляем 1 к R1 и R5

; ───────────────────────────────────────────────────────────────────────────

jmp_2356:       ; вывод дополнительной информации
                jsr     R4, @#110346
                mov     R5, -(SP)
                call    CalcFileAddres  ; расчёт реального адреса, на котором стоит курсор
                                        ; Выход: R5 - адрес
                mov     R5, CURADR      ; текущий адрес в файле
                mov     #40, R1
                call    OutNumOct$SL    ; Вывод восьмеричного числа в служебную строку
                                        ; Вход: R1 - координаты
                                        ;       R5 - число
                mov     #57, R1
                mov     (SP), R0
                call    OutNumberSL     ; Вывод числа в текущей системе счисления в служебную строку
                                        ; Вход: R0 - адрес
                mov     (SP), R3
                bic     #1, R3
                bic     #1, CURADR      ; текущий адрес в файле
                mov     @#160, -(SP)
                mov     #76643, @#160
                call    Disassemble     ; Вывод текущего дизассемблированного кода под курсором
                mov     @#160, R2       ; очистка всего, что справа от выведенной инструкции
1$:             mov     R2, R1
2$:             clrb    (R1)+
                bit     #77, R1
                bne     2$
                add     #100, R2
                bpl     1$
                mov     (SP)+, @#160
                mov     (SP)+, R5
                jsr     R4, @#110362
                ; установка курсора и приём управляющих кодов с клавиатуры
                emt     24
                mov     #240, R0        ; длительность задержки
                call    Inkey$ND        ; Приём кода с клавиатуры с автоповтором, с заданной задержкой
                cmpb    R0, #30         ; Забой
                bne     3$
                movb    #10, R0         ; заменяем забой на стрелку влево
3$:             cmpb    R0, #23         ; ВС
                beq     4$
                jmp     jmp_5654        ; продолжаем обработку кодов с клавиатуры

4$:             call    Input$LC        ; Приём кода с клавиатуры с ожиданием
                                        ; и приведение символов к Лат.Загл.

; ── Обработка кодов команд после префикса ──────────────────────────────────

jmp_2550:       bic     #177640, R0
                mov     R0, -(SP)
                clr     R0
                br      6$

5$:             inc     R0
                tstb    KeyCodes(R0)
                beq     7$
6$:             cmpb    (SP), KeyCodes(R0)
                bne     5$
                asl     R0
                tst     (SP)+
                jmp     @KCProcs(R0)

7$:             tst     (SP)+           ; префиксной команды не нашли
                br      jmp_2356        ; возвращаемся к началу
; End of function jmp_2356


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Ввод байта (только в поле символов)

ByteEnter:      tstb    FLAG            ; Флаг курсора: 0 - курсор в поле цифр,
                                        ;               1 - курсор в поле символов
                beq     jmp_2356
                mov     R5, -(SP)
                call    InitCursorPos
                jsr     R1, OutStrI
                .asciz " Byte ("
                .even
                movb    (R5), R1        ; берём байт
                mov     #8., R0         ; делаем swab R1
1$:             asl     R1              ; сложным способом
                sob     R0, 1$
                clr     R0
                mov     #3, R2          ; выводим его на экран
                br      3$

2$:             clr     R0
                rol     R1
                rol     R0
3$:             rol     R1
                rol     R0
                rol     R1
                rol     R0
                add     #'0, R0
                emt     16
                sob     R2, 2$
                jsr     R1, OutStrI
                .asciz ")="
                .even
                emt     6
                cmp     R0, #12
                beq     4$
                call    InputNumber1    ; Ввод числа с клавиатуры, в понимаемых системах счисления
                                        ; Вход:  R0 - первый код нажатой клавиши
                                        ; Выход: R5 - число
                movb    R5, @0(SP)
4$:             mov     (SP)+, R5
                jmp     DrawDump
; End of function ByteEnter


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Вниз на 400 байт

StepDn400b:     add     #400, R5
                mov     BUFFER, R0      ; адрес начала буфера
                add     #1000, R0
                cmp     R5, R0
                blo     400$
                sub     #1000, R5
                mov     BLK, R0
                inc     R0

loc_3004:       call    Replace$        ; Подсчёт КС блока - буфера и перезапись
                                        ; по запросу "Replace?" при несовпадении.
                jmp     jmp_1460
; End of function StepDn400b


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Вверх на 400 байт

StepUp400b:     sub     #400, R5
                cmp     R5, BUFFER      ; адрес начала буфера
                bhis    400$
                add     #1000, R5
                mov     BLK, R0
                dec     R0
                br      loc_3004

400$:           jmp     DrawDump
; End of function StepUp400b


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Выбор блока

SelectBlock:    mov     BLK, R0
                call    Replace$        ; Подсчёт КС блока - буфера и перезапись
                                        ; по запросу "Replace?" при несовпадении.
                call    InitCursorPos
                jsr     R1, OutStrI
                .asciz "Block :"
                .even
                call    InputNumber     ; Ввод числа с клавиатуры, в понимаемых системах счисления
                                        ; Выход: R5 - число
                mov     R5, BLK
                jmp     jmp_1454
; End of function SelectBlock


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Ввести мнемонику

EnterMnemonic:  bic     #1, R5
                mov     R5, -(SP)
                mov     #43, R1
                mov     #27, R2
                emt     24
                mov     #231, R0
                emt     16
                mov     BUFFER, R3      ; адрес начала буфера
                add     #1110, R3
                call    STROKA
                mov     BUFFER, R4      ; адрес начала буфера
                add     #1102, R4
                call    Assemble
                bcs     2$
                mov     (SP), R2
                mov     BUFFER, R3      ; адрес начала буфера
                add     #1102, R3
1$:             mov     (R3)+, (R2)+
                cmp     R3, R4
                blo     1$
2$:             mov     (SP)+, R5
                jmp     DrawDump
; End of function EnterMnemonic


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Выход из программы

Exit:           mov     R5, -(SP)
                mov     BLK, R0
                call    Replace$        ; Подсчёт КС блока - буфера и перезапись
                                        ; по запросу "Replace?" при несовпадении.
                call    InitCursorPos
                jsr     R1, OutStrI
                .asciz "Exit?"
                .even

loc_3250:       call    GetConfirm
                cmpb    R1, #'N
                bne     2$
                jmp     jmp_2070

2$:             emt     4
                .addr   R1,ExitMem
3$:             clr     (R1)+
                tst     R1
                bpl     3$
                mov     R1, PC
; End of function Exit


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Аварийный выход из программы

Quit:           mov     R5, -(SP)
ExitMem:        call    InitCursorPos
                jsr     R1, OutStrI
                .asciz "Quit?"
                .even
                br      loc_3250
; End of function Quit


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Переход к адресу

GotoAddr:       mov     R5, -(SP)
                call    InitCursorPos
                jsr     R1, OutStrI
                .asciz "Address :"
                .even
                call    InputNumber     ; Ввод числа с клавиатуры, в понимаемых системах счисления
                                        ; Выход: R5 - число

loc_3360:       sub     OFSADR, R5
                mov     R5, R0
                bic     #177000, R5
                add     BUFFER, R5      ; адрес начала буфера
                clrb    R0
                swab    R0
                asr     R0
                add     OFSBLK, R0
                mov     (SP), R1
                mov     BLK, (SP)
                mov     R1, -(SP)
                mov     R0, BLK
                jmp     jmp_5344
; End of function GotoAddr


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Переход по содержимому ячейки (37)

JumpOnAddr:     mov     R5, -(SP)
                mov     (R5), R5
                br      loc_3360
; End of function JumpOnAddr


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Переход по смещению в ячейке (67)

JumpOnOffset:   mov     R5, -(SP)
                mov     (R5)+, R1
                call    CalcFileAddres  ; расчёт реального адреса, на котором стоит курсор
                                        ; Выход: R5 - адрес
                add     R1, R5
                br      loc_3360
; End of function JumpOnOffset


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Задание смещения

SetOffset:      call    InitCursorPos
                jsr     R1, OutStrI
                .asciz "Offset:"
                .even

                mov     R5, -(SP)
                call    InputNumber     ; Ввод числа с клавиатуры, в понимаемых системах счисления
                                        ; Выход: R5 - число
                sub     (SP), R5
                add     BUFFER, R5      ; адрес начала буфера
                mov     R5, OFSADR
                mov     BLK, OFSBLK
                jmp     jmp_2070
; End of function SetOffset


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Шаг на одну машинную команду

Trace:          mov     R5, R3
                mov     R5, -(SP)
                mov     @#20, -(SP)
                mov     PC, R1
                br      1$

                rti

1$:             tst     (R1)+           ; в R1 адрес команды RTI
                mov     R1, @#20
                call    Disassemble     ; Вывод текущего дизассемблированного кода под курсором
                mov     (SP)+, @#20
                mov     (SP)+, R2
                mov     R3, R5
                mov     BUFFER, R0      ; адрес начала буфера
                add     #1000, R0
                cmp     R5, R0
                bhis    3$
                bic     #377, R2
                sub     R2, R3
                cmp     R3, #400
                bhis    2$
                mov     R5, -(SP)
                jmp     jmp_2070

2$:             jmp     DrawDump

3$:             mov     BLK, R0
                inc     R0
                call    Replace$        ; Подсчёт КС блока - буфера и перезапись
                                        ; по запросу "Replace?" при несовпадении.
                sub     #1000, R5
                jmp     jmp_1460
; End of function Trace


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Выбор устройства (КТ - отмена)

SelectDevice:   mov     BLK, R0
                call    Replace$        ; Подсчёт КС блока - буфера и перезапись
                                        ; по запросу "Replace?" при несовпадении.
                jmp     InputDev$
; End of function SelectDevice


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Скопировать блок на [D]evice, [B]lock

CopyBlock:      mov     R4, -(SP)
                mov     R5, -(SP)
                jsr     R4, @#110346
                mov     BLK, -(SP)
                movb    DEV, R0
                mov     R0, -(SP)
                call    InitCursorPos
                jsr     R1, OutStrI
                .asciz "Saved in "
                .even
                emt     6
                cmpb    R0, #12
                beq     3$
                cmpb    R0, #'B
                beq     1$
                cmpb    R0, #'D
                bne     2$
                call    GetDevName
                mov     #40, R0
                emt     16
1$:             mov     #10, R0
2$:             mov     R0, -(SP)
                jsr     R1, OutStrI
                .asciz "Block :"
                .even
                mov     (SP)+, R0
                call    InputNumber1    ; Ввод числа с клавиатуры, в понимаемых системах счисления
                                        ; Вход:  R0 - первый код нажатой клавиши
                                        ; Выход: R5 - число
                mov     R5, BLK
                mov     #400, R1
                neg     R1
                call    RWBlkErrHandl   ; Чтение/запись блока с обработкой ошибок
                call    OFF             ; останов двигателя, подсчёт КС и вывод в служебную строку номера блока
                                        ; находящегося в буфере
3$:             mov     (SP)+, R0
                movb    R0, DEV
                mov     (SP)+, BLK
                call    OutBlkNum$SL        ; Вывод в служебную строку номера блока в буфере
                jsr     R4, @#110362
                mov     (SP)+, R5
                mov     (SP)+, R4
                emt     24
                call    ClearCmdLn
                jmp     jmp_2356
; End of function CopyBlock


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Записать блок на диск

ReplaceBlock:   call    ReplaceFN
                jmp     jmp_2356
; End of function ReplaceBlock


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Задать вид дополнительной информации

SetInfoType:    call    InitCursorPos
                jsr     R1, OutStrI
                .asciz " Information "
                .even

                call    Input$LC        ; Приём кода с клавиатуры с ожиданием
                                        ; и приведение символов к Лат.Загл.
                .addr   R1, StrOctal
                mov     #7, R2
                cmp     R0, #'O
                bne     1$
                emt     20
                movb    #3, INFFLG      ; Режим вывода данных: 0 - dec, 1 - bin, >=2 - oct
                movb    #8., INF        ; Система счисления выводимых чисел: 10. - dec, 2 - bin, 8. - oct
                br      3$

1$:             add     #StrDecimal-StrOctal, R1
                cmp     R0, #'D
                bne     2$
                emt     20
                clrb    INFFLG          ; Режим вывода данных: 0 - dec, 1 - bin, >=2 - oct
                movb    #10., INF       ; Система счисления выводимых чисел: 10. - dec, 2 - bin, 8. - oct
                br      3$

2$:             add     #StrBinary-StrDecimal, R1
                cmp     R0, #'B
                bne     3$
                emt     20
                movb    #1, INFFLG      ; Режим вывода данных: 0 - dec, 1 - bin, >=2 - oct
                movb    #2, INF         ; Система счисления выводимых чисел: 10. - dec, 2 - bin, 8. - oct

3$:             mov     R5, -(SP)
                jmp     jmp_2070
; End of function SetInfoType

; ───────────────────────────────────────────────────────────────────────────
; Вывод справки
HelpOut:
                jsr     R1, OutStrI
                .byte 14, 232, 233, 224, 236, 233, 22, 0
                .even

                .addr   R1, StrHelp
1$:             movb    (R1)+, R0
                bne     2$
                movb    #12, R0
                br      5$

2$:             cmpb    R0, #176 ; '~'
                bne     3$
                cmpb    (R1), R0
                beq     7$
                call    Input$LC        ; Приём кода с клавиатуры с ожиданием
                                        ; и приведение символов к Лат.Загл.
                cmpb    R0, #'N
                beq     8$
                mov     #14, R0
                iot
                br      1$

3$:             cmpb    R0, #40
                bhis    5$
                mov     R0, -(SP)
                mov     #40, R0
4$:             iot
                dec     (SP)
                bne     4$
                tst     (SP)+
                br      6$

5$:             iot
6$:             sob     R2, 1$

7$:             call    Inkey$
8$:             mov     #115014, R0
                emt     16
                swab    R0
                emt     16
                jmp     DrawDump

; ───────────────────────────────────────────────────────────────────────────
; Задать модель поиска
SetSearchModel: call    InitCursorPos
                mov     R5, -(SP)
                jsr     R1, OutStrI
                .asciz " Model "
                .even

                call    Input$LC        ; Приём кода с клавиатуры с ожиданием
                                        ; и приведение символов к Лат.Загл.
                cmpb    R0, #12
                beq     3$
                clrb    MODFLG
                cmpb    R0, #'W
                beq     1$
                cmpb    R0, #'A
                beq     6$
                cmpb    R0, #'B
                beq     4$
                cmpb    R0, #'M
                beq     5$
                cmpb    R0, #20
                blo     3$
                cmpb    R0, #31
                bhi     7$
                bis     #40, R0
                br      2$

1$:             mov     #10, R0
2$:             mov     R0, -(SP)
                jsr     R1, OutStrI
                .asciz "Word="
                .even
                mov     (SP)+, R0
                call    InputNumber1    ; Ввод числа с клавиатуры, в понимаемых системах счисления
                                        ; Вход:  R0 - первый код нажатой клавиши
                                        ; Выход: R5 - число
                mov     R5, MOD
3$:             jmp     jmp_2070

4$:             jsr     R1, OutStrI
                .asciz "Byte="
                .even
                call    InputNumber     ; Ввод числа с клавиатуры, в понимаемых системах счисления
                                        ; Выход: R5 - число
                mov     R5, MOD
                movb    #1, MODFLG
                br      3$

5$:             jsr     R1, OutStrI
                .asciz "Macro-11:"
                .even
                mov     BUFFER, R3      ; адрес начала буфера
                add     #1110, R3
                call    STROKA
                cmpb    (R3), #12
                beq     3$
                mov     BUFFER, R3      ; адрес начала буфера
                mov     R3, R4
                add     #1110, R3
                add     #1102, R4
                mov     R4, MOD
                call    Assemble
                mov     BUFFER, R0      ; адрес начала буфера
                mov     R4, 1100(R0)
                movb    #3, MODFLG
                br      3$

6$:             mov     #10, R0
7$:             mov     R0, -(SP)
                jsr     R1, OutStrI
                .asciz "Ascii :"
                .even
                mov     (SP)+, R0
                mov     BUFFER, R3      ; адрес начала буфера
                add     #1102, R3
                mov     R3, MOD
                mov     R3, R1
                call    sub_11354
                cmpb    (R3), #12
                beq     3$
                mov     R1, -(R3)
                movb    #2, MODFLG
                br      3$

; ───────────────────────────────────────────────────────────────────────────
; Поменять курсор с меткой
CursorXchgLbl:  mov     BLK, -(SP)
                mov     R5, -(SP)
                mov     METADR, R5
                mov     METBLK, R0
                cmp     R0, BLK
                beq     1$
                call    Replace$        ; Подсчёт КС блока - буфера и перезапись
                                        ; по запросу "Replace?" при несовпадении.
                br      2$

1$:             mov     R0, BLK
2$:             mov     2(SP), METBLK
                mov     (SP), METADR
                br      jmp_5344

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Поставить метку

SetLabel:       mov     R5, METADR
                mov     BLK, METBLK
                jmp     jmp_2356
; End of function SetLabel

; ───────────────────────────────────────────────────────────────────────────
; Поиск модели, КТ - остановить

Search:         mov     BLK, -(SP)
                mov     R5, -(SP)
                tstb    FLAG            ; Флаг курсора: 0 - курсор в поле цифр,
                                        ;               1 - курсор в поле символов
                bne     1$
                cmp     #10, R3
                blt     1$
                inc     R5
                mov     R5, (SP)
1$:             call    CursorSwitch    ; Переключение режима индикации курсора
                tstb    MODFLG
                beq     jmp_5164
                dec     R5

jmp_5164:       tst     (R5)+
                cmpb    MODFLG, #2
                bhis    6$
                mov     BUFFER, R0      ; адрес начала буфера
                add     #1000, R0
                cmp     R5, R0
                bhis    14$
                cmpb    #1, MODFLG
                beq     4$
                cmp     MOD, (R5)
                bne     jmp_5164
                br      loc_5340

3$:             inc     R5
4$:             mov     BUFFER, R0      ; адрес начала буфера
                add     #1000, R0
                cmp     R5, R0
                bhis    14$
                cmpb    MOD, (R5)
                beq     loc_5340
                br      3$

5$:             inc     R5
6$:             mov     BUFFER, R0      ; адрес начала буфера
                add     #1000, R0
                cmp     R5, R0
                bhis    14$
                mov     R5, R1
                mov     MOD, R2
7$:             cmpb    (R1)+, (R2)+
                bne     5$
                mov     BUFFER, R0      ; адрес начала буфера
                cmp     R2, 1100(R0)
                bne     7$
                cmpb    MODFLG, #3
                bne     loc_5340
                bit     #1, R5
                bne     5$

loc_5340:       call    CursorSwitch    ; Переключение режима индикации курсора
jmp_5344:       mov     (SP), R1
                mov     2(SP), R2
                mov     R5, (SP)
                mov     BLK, 2(SP)
                cmp     BLK, R2
                bne     12$
                mov     R5, R0
                bic     #177600, R0
                cmp     R0, #400
                blo     10$
                cmp     R0, #410
                blo     13$
10$:            xor     R1, R5
                bit     #400, R5
                bne     13$
                mov     (SP)+, R5
                mov     (SP)+, BLK
                mov     R5, -(SP)
                jmp     jmp_2070

11$:            call    CursorSwitch    ; Переключение режима индикации курсора
12$:            mov     2(SP), BLK
                mov     #400, R1
                call    RWBlkErrHandl   ; Чтение/запись блока с обработкой ошибок
                call    OFF             ; останов двигателя, подсчёт КС и вывод в служебную строку номера блока
                                        ; находящегося в буфере
13$:            mov     (SP)+, R5
                mov     (SP)+, BLK
                jmp     DrawDump

14$:            mov     #BLK, R0
                cmp     2(SP), (R0)
                bne     15$
                mov     (R0), R0
                call    CursorSwitch    ; Переключение режима индикации курсора
                call    Replace$        ; Подсчёт КС блока - буфера и перезапись
                                        ; по запросу "Replace?" при несовпадении.
                call    sub_5624
                mov     #BLK, R0

15$:            inc     (R0)
                cmp     (R0), SIZ
                bhis    11$
                call    OutBlkNum$SL    ; Вывод в служебную строку номера блока в буфере
                mov     #440, R1
                call    RWBlkErrHandl   ; Чтение/запись блока с обработкой ошибок
                mov     BUFFER, R5      ; адрес начала буфера
                tst     -(R5)
                bit     #100, @#177716
                bne     16$
                movb    @#177662, R0
                cmpb    R0, #3
                beq     17$
16$:            tstb    @#ERRFDD
                bne     17$
                jmp     jmp_5164

17$:            tst     (R5)+
                br      loc_5340

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


sub_5624:       call    ClearCmdLn
                jsr     R1, OutStrI
                .asciz <232><32>" Search ..."
                .even
                return
; End of function sub_5624

; ── продолжение обработки клавиатуры ───────────────────────────────────────

jmp_5654:       cmp     R0, #12         ; Ввод - курсор в поле символов и обратно
                bne     3$
                tstb    FLAG            ; Флаг курсора: 0 - курсор в поле цифр,
                                        ;               1 - курсор в поле символов
                bne     2$
                incb    FLAG            ; Флаг курсора: 0 - курсор в поле цифр,
                                        ;               1 - курсор в поле символов
                call    SwitchToCharField ; Меняем местами R1 и R4
                                        ; если R3 > 10 то прибавляем 1 к R1 и R5
1$:             jmp     jmp_2356

2$:             clrb    FLAG            ; Флаг курсора: 0 - курсор в поле цифр,
                                        ;               1 - курсор в поле символов
                call    SwitchToDataField ; Меняем местами R1 и R4
                                        ; если R5 нечётное то вычитаем 1 из R1 и R5
                br      1$

3$:             cmp     R0, #10         ; стрелка влево
                bne     10$
                cmp     #11, R1
                bne     4$
                mov     #75, R4
                br      5$

4$:             cmp     #63, R1
                bne     6$
                inc     R5
                mov     #61, R4
                mov     #26, R1
5$:             clr     R3
                add     #50, R1
                add     #12, R5
                br      18$

6$:             dec     R1
                tstb    FLAG            ; Флаг курсора: 0 - курсор в поле цифр,
                                        ;               1 - курсор в поле символов
                bne     8$
                add     #3, R3
                cmp     #17, R3
                bge     1$
                tst     -(R5)
                dec     R1
                tst     -(R4)
                clr     R3
7$:             br      1$

8$:             dec     R5
                bit     #1, R5
                beq     9$
                sub     #22, R3
                dec     R4
9$:             sub     #3, R4
                add     #11, R3
                br      1$

10$:            cmp     #31, R0         ; стрелка вправо
                bne     17$
11$:            cmp     #61, R1
                bne     12$
                mov     #11, R1
                mov     #63, R4
                br      13$

12$:            cmp     #76, R1
                bne     14$
                dec     R5
                mov     #63, R1
                mov     #11, R4
13$:            sub     #12, R5
                mov     #17, R3
                br      22$

14$:            inc     R1
                tstb    FLAG            ; Флаг курсора: 0 - курсор в поле цифр,
                                        ;               1 - курсор в поле символов
                bne     15$
                sub     #3, R3
                bge     1$
                mov     #17, R3
                mov     BUFFER, R0      ; адрес начала буфера
                add     #776, R0
                cmp     R5, R0
                beq     22$
                tst     (R5)+
                tst     (R4)+
                inc     R1
                br      1$

15$:            inc     R5
                bit     #1, R5
                bne     16$
                add     #22, R3
                inc     R4
                mov     BUFFER, R0      ; адрес начала буфера
                add     #1000, R0
                cmp     R5, R0
                beq     22$
16$:            add     #3, R4
                sub     #11, R3
                br      7$

17$:            cmp     R0, #32         ; стрелка вверх
                bne     21$
18$:            tst     R2
                bne     19$
                add     #360, R5
                jmp     StepUp400b

19$:            dec     R2
                sub     #14, R5
20$:            br      7$

21$:            cmp     R0, #33         ; стрелка вниз
                bne     24$
22$:            cmp     R2, #25
                bne     23$
                sub     #374, R5
                jmp     StepDn400b

23$:            inc     R2
                add     #14, R5
                mov     BUFFER, R0      ; адрес начала буфера
                add     #1000, R0
                cmp     R5, R0
                blo     7$
                br      22$

; остальные коды
24$:            call    CursorSwitch    ; Переключение режима индикации курсора
                tstb    FLAG            ; Флаг курсора: 0 - курсор в поле цифр,
                                        ;               1 - курсор в поле символов
                beq     27$
                bitb    #140, R0
                bne     25$
                call    CursorSwitch    ; Переключение режима индикации курсора
                br      20$

25$:            emt     16
                movb    R0, (R5)
                mov     R1, -(SP)
                mov     R4, -(SP)
                call    sub_10162
                mov     (SP)+, R4
                emt     24
                mov     (SP)+, R1
                mov     R5, -(SP)
                mov     (R5), R5
                call    OutNumOct       ; Вывод восьмеричного числа на экран
                                        ; Вход: R5 - число
                mov     (SP)+, R5
26$:            emt     24
                call    CursorSwitch    ; Переключение режима индикации курсора
                br      11$

27$:            cmp     #'0, R0
                bgt     33$
                cmp     #'7, R0
                blt     33$
                cmp     R3, #17
                bne     28$
                cmp     #'0, R0
                beq     28$
                mov     #'1, R0
28$:            emt     16
                sub     #'0, R0
                mov     R4, -(SP)
                mov     R3, -(SP)
                mov     #7, R4
                tst     R3
                beq     30$
29$:            asl     R4
                asl     R0
                sob     R3, 29$

30$:            bic     R4, (R5)
                bis     R0, (R5)
                mov     (SP)+, R3
                mov     (SP)+, R4
                call    SwitchToCharField       ; Меняем местами R1 и R4
                                        ; если R3 > 10 то прибавляем 1 к R1 и R5
                emt     24
                bit     #1, R5
                bne     31$
                movb    (R5)+, R0
                call    SetSafeChr       ; Замена непечатных символов на точку
                emt     16
                movb    (R5), R0
                call    SetSafeChr       ; Замена непечатных символов на точку
                emt     16
                dec     R5
                mov     #10, R0
                emt     16
                br      32$

31$:            mov     #10, R0
                emt     16
                movb    -(R5), R0
                inc     R5
                call    SetSafeChr       ; Замена непечатных символов на точку
                emt     16
                movb    (R5), R0
                call    SetSafeChr       ; Замена непечатных символов на точку
                emt     16
32$:            call    SwitchToDataField       ; Меняем местами R1 и R4
                                        ; если R5 нечётное то вычитаем 1 из R1 и R5
                br      26$

33$:            call    CursorSwitch    ; Переключение режима индикации курсора
                cmp     R0, #'+
                bne     34$
                br      35$

34$:            cmp     R0, #'-
                bne     38$
                ;+/- - прибавить/отнять число к/от содержимого ячейки
35$:            jsr     R4, @#110346
                mov     R5, -(SP)
                call    InitCursorPos
                mov     (SP), R5
                mov     (R5), R5
                call    OutNumOct       ; Вывод восьмеричного числа на экран
                                        ; Вход: R5 - число
                mov     2(SP), R0
                emt     16
                call    InputNumber     ; Ввод числа с клавиатуры, в понимаемых системах счисления
                                        ; Выход: R5 - число
                mov     R5, R0
                mov     (SP)+, R5
                cmp     (SP), #'+
                bne     36$
                add     R0, (R5)
                br      37$

36$:            sub     R0, (R5)
37$:            call    ClearCmdLn
                jsr     R4, @#110362
                emt     24
                jmp     DrawDump

38$:            cmp     R0, #'=         ; присвоить число ячейке
                bne     39$
                jsr     R4, @#110346
                mov     R5, -(SP)
                call    InitCursorPos
                jsr     R1, OutStrI
                .asciz " Value="
                .even
                call    InputNumber     ; Ввод числа с клавиатуры, в понимаемых системах счисления
                                        ; Выход: R5 - число
                mov     R5, @0(SP)
                mov     (SP)+, R5
                br      37$

39$:            jmp     jmp_2550        ; Обработка кодов команд после префикса
; ───────────────────────────────────────────────────────────────────────────
StrDESS:        .ascii "*DESS* "
StrDriveName:   .asciz "?: Blk:"
                .asciz "Adr:"
StrOctal:       .asciz " Octal :"
StrDecimal:     .asciz "Decimal:"
StrBinary:      .asciz "Binary :"

KeyCodes:       .byte 32    ; стрелка вверх
                .byte 33    ; стрелка вниз
                .byte 35    ; равно
                .byte 14    ; СБР
                .byte 20    ; ШАГ
                .byte 'A
                .byte 'B
                .byte 'C
                .byte 'E
                .byte 'Q
                .byte '@
                .byte '_
                .byte 'O
                .byte 'T
                .byte 'D
                .byte 'Z
                .byte 'R
                .byte 'I
                .byte 'H
                .byte 'M
                .byte 'S
                .byte 'U
                .byte 25    ;СУ/U
                .byte 'F
                .byte 0
                .even

KCProcs:        .word StepUp400b        ; Вверх на 400 байт
                .word StepDn400b        ; Вниз на 400 байт
                .word ByteEnter         ; Ввод байта (только в поле символов)
                .word SetLabel          ; Поставить метку
                .word CursorXchgLbl     ; Поменять курсор с меткой
                .word GotoAddr          ; Переход к адресу
                .word SelectBlock       ; Выбор блока
                .word EnterMnemonic     ; Ввести мнемонику
                .word Exit              ; Выход из программы
                .word Quit              ; Аварийный выход из программы
                .word JumpOnAddr        ; Переход по содержимому ячейки (37)
                .word JumpOnOffset      ; Переход по смещению в ячейке (67)
                .word SetOffset         ; Задание смещения
                .word Trace             ; Шаг на одну машинную команду
                .word SelectDevice      ; Выбор устройства (КТ - отмена)
                .word CopyBlock         ; Скопировать блок на [D]evice, [B]lock
                .word ReplaceBlock      ; Записать блок на диск
                .word SetInfoType       ; Задать вид дополнительной информации
                .word HelpOut           ; Вывод справки
                .word SetSearchModel    ; Задать модель поиска
                .word Search            ; Поиск модели, КТ - остановить
                .word CallUser          ; Передача управления функции пользователя
                .word LoadUser          ; Загрузка функции пользователя
                .word GotoFile          ; Переход к файлу (АНДОС, МКДОС)

DECConst:       .word 10000., 1000., 100., 10., 1

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; расчёт реального адреса, на котором стоит курсор
; Выход: R5 - адрес

CalcFileAddres: sub     BUFFER, R5     ; адрес начала буфера
                add     OFSADR, R5
                mov     BLK, R0
                sub     OFSBLK, R0
                swab    R0
                clrb    R0
                asl     R0
                add     R0, R5
                return
; End of function CalcFileAddres


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Вывод восьмеричного числа на экран
; Вход: R5 - число

OutNumOct:      mov     R1, -(SP)
                clr     R0
                mov     #6, R1
                br      2$

1$:             clr     R0
                rol     R5
                rol     R0
                rol     R5
                rol     R0
2$:             rol     R5
                rol     R0
                add     #'0, R0
                emt     16
                sob     R1, 1$
                mov     (SP)+, R1
                return
; End of function OutNumOct


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вывод в служебную строку номера блока в буфере

OutBlkNum$SL:   mov     #16, R1
                mov     BLK, R5
                call    OutNumOct$SL    ; Вывод восьмеричного числа в служебную строку
                                        ; Вход: R1 - координаты
                                        ;       R5 - число
                inc     R1
                mov     BLK, R5
                jmp     OutDecimalData  ; Вывод десятичного слова или байта в служебную строку
                                        ; Вход: R5 - число
; End of function OutBlkNum$SL


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вывод восьмеричного числа на экран через IOT
; Вход: R5 - число

OutNumOct$F:    mov     R1, -(SP)
                clr     R0
                mov     #6, R1
                br      2$

1$:             clr     R0
                rol     R5
                rol     R0
                rol     R5
                rol     R0
2$:             rol     R5
                rol     R0
                add     #'0, R0
                iot
                sob     R1, 1$
                mov     (SP)+, R1
                add     #6, @#156       ; Номер символа на экране
                return
; End of function OutNumOct$F


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вывод восьмеричного числа на экран через IOT с подавлением ведущих нулей
; Вход: R4 - число

OutNumOct$FNS:  mov     R1, -(SP)
                clr     -(SP)
                clr     R0
                mov     #6, R1
                br      2$

1$:             clr     R0
                rol     R4
                rol     R0
                rol     R4
                rol     R0
2$:             rol     R4
                rol     R0
                bne     3$
                tst     (SP)
                bne     3$
                cmp     #1, R1
                bne     4$
3$:             add     #'0, R0
                iot
                inc     (SP)
                incb    @#156
4$:             sob     R1, 1$
                tst     (SP)+
                mov     (SP)+, R1
                return
; End of function OutNumOct$FNS


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вывод восьмеричного числа в служебную строку
; Вход: R1 - координаты
;       R5 - число

OutNumOct$SL:   mov     R2, -(SP)
                clr     R0
                mov     #6, R2
                br      2$

1$:             clr     R0
                rol     R5
                rol     R0
                rol     R5
                rol     R0
2$:             rol     R5
                rol     R0
                add     #'0, R0
                inc     R1
                emt     22
                sob     R2, 1$
                mov     (SP)+, R2
                return
; End of function OutNumOct$SL


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вывод восьмеричного слова или байта в служебную строку
; Вход: R5 - число

OutOctalData:   tstb    FLAG            ; Флаг курсора: 0 - курсор в поле цифр,
                                        ;               1 - курсор в поле символов
                beq     OutNumOct$SL    ; Вывод восьмеричного числа в служебную строку
                                        ; Вход: R1 - координаты
                                        ;       R5 - число
                swab    R5              ; выведем байт
                clr     R0
                mov     #3, R2
                br      2$

1$:             clr     R0
                rol     R5
                rol     R0
2$:             rol     R5
                rol     R0
                rol     R5
                rol     R0
                add     #'0, R0
                inc     R1
                emt     22
                sob     R2, 1$
                mov     #3, R2          ; и 3 пробела
; Вывод пробелов в служебную строку
; Вход: R1 - координата
;       R2 - количество побелов
OutSpacesSL:    mov     #40, R0
4$:             inc     R1
                emt     22
                sob     R2, 4$
                return
; End of function OutOctalData


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Вывод числа в текущей системе счисления в служебную строку
; Вход: R0 - адрес

OutNumberSL:    tstb    FLAG            ; Флаг курсора: 0 - курсор в поле цифр,
                                        ;               1 - курсор в поле символов
                beq     1$
                movb    (R0), R5
                bic     #177400, R5
                br      2$

1$:             mov     (R0), R5
2$:             movb    INF, R4         ; Система счисления выводимых чисел: 10. - dec, 2 - bin, 8. - oct
                cmpb    R4, #8.
                bne     3$
                jmp     OutOctalData    ; Вывод восьмеричного слова или байта в служебную строку
                                        ; Вход: R5 - число

3$:             cmpb    R4, #2
                beq     OutBinaryData

; ───────────────────────────────────────────────────────────────────────────
; Вывод десятичного слова или байта в служебную строку
; Вход: R5 - число

OutDecimalData: mov     #'0, R0
                .addr   R2, DECConst
                mov     #5, R3
1$:             cmp     R5, (R2)
                blo     2$
                incb    R0
                sub     (R2), R5
                br      1$

2$:             inc     R1
                emt     22
                mov     #'0, R0
                tst     (R2)+
                sob     R3, 1$
                inc     R1
                mov     #'., R0
                emt     22
                return

; ───────────────────────────────────────────────────────────────────────────
; Вывод двоичного слова или байта в служебную строку
; Вход: R5 - число

OutBinaryData:  tstb    FLAG            ; Флаг курсора: 0 - курсор в поле цифр,
                                        ;               1 - курсор в поле символов
                bne     2$
                mov     #16., R2

1$:             clr     R0
                rol     R5
                rol     R0
                add     #'0, R0
                inc     R1
                emt     22
                sob     R2, 1$
                return

2$:             mov     #8., R2
                swab    R5
3$:             clr     R0
                rol     R5
                rol     R0
                add     #'0, R0
                inc     R1
                emt     22
                sob     R2, 3$
                mov     #8., R2
                jmp     OutSpacesSL     ; Вывод пробелов в служебную строку
                                        ; Вход: R1 - координата
                                        ;       R2 - количество побелов
; End of function OutNumberSL


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Меняем местами R1 и R4
; если R3 > 10 то прибавляем 1 к R1 и R5

SwitchToCharField:
                mov     R4, -(SP)
                mov     R1, R4
                mov     (SP)+, R1
                cmp     #10, R3
                blt     1$
                inc     R5
                inc     R1
1$:             return
; End of function SwitchToCharField


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Меняем местами R1 и R4
; если R5 нечётное то вычитаем 1 из R1 и R5

SwitchToDataField:
                mov     R4, -(SP)
                mov     R1, R4
                mov     (SP)+, R1
                bit     #1, R5
                beq     1$
                dec     R5
                dec     R4
1$:             return
; End of function SwitchToDataField


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


SetSafeChr:     bitb    #140, R0
                bne     1$
                mov     #'., R0
1$:             return
; End of function SetSafeChr


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


sub_10162:      sub     #61, R1
                asr     R1
                mov     #2, R4
1$:             add     #7, R4
                sob     R1, 1$
                mov     R4, R1
                return
; End of function sub_10162


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; ожидание подтверждения.
; конец ожидания - клавиша ввод.
; Выход: R1 - код подтверждения

GetConfirm:
0$:             bit     #100, @#177716  ; ждём нажатия клавиши
                beq     0$
1$:             bit     #100, @#177716
                bne     1$
                clrb    @#105           ; принимаем код
                movb    @#177662, R0
                bitb    #140, R0        ; это печатный символ?
                beq     2$              ; нет
                emt     16              ; да - выведем на экран
                bicb    #240, R0        ; и сделаем из него лат.загл.
                mov     R0, R1          ; и сохраним тут

2$:             cmpb    R0, #30         ; это забой?
                bne     3$              ; нет
                emt     16              ; да - выполним действие

3$:             cmpb    R0, #12         ; это ввод?
                bne     GetConfirm      ; нет - снова ждать кода
                return                  ; да - выход
; End of function GetConfirm


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Приём кода с клавиатуры с ожиданием
; и приведение символов к Лат.Загл.

Input$LC:       call    InputKey        ; Приём кода с клавиатуры с ожиданием
                bic     #177640, R0
                return
; End of function Input$LC


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Приём кода с клавиатуры с ожиданием

InputKey:       emt     6               ; ждём код с клавиатуры
                cmpb    R0, #222        ; это клавиша ИСУ ?
                beq     1$              ; да
                return                  ; нет - выходим

1$:             call    PRINT           ; печать копии экрана на принтере
                br      InputKey
; End of function InputKey


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Приём кода с клавиатуры с автоповтором

Inkey$:         mov     #13000, R0
Inkey$ND:       sob     R0, .

1$:             bit     #100, @#177716
                beq     2$
                call    InputKey        ; Приём кода с клавиатуры с ожиданием
                mov     #10000, ARDelay
                return

2$:             dec     ARDelay
                bmi     3$
                bne     1$
3$:             mov     #4, R0
                call    BEEP
                movb    @#104, R0
                return

ARDelay:        .word 10000
; End of function Inkey$ND

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


BEEP:           mov     R2, -(SP)
                mov     R3, -(SP)
                mov     R0, R2
                bic     #177700, R2
                call    @#102056
                mov     (SP)+, R3
                mov     (SP)+, R2
                return
; End of function BEEP


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


OutStrI:        clr     R2
                emt     20
                inc     R1
                bic     #1, R1
                rts     R1
; End of function OutStrI


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; запрос номера текущего устройства

GetDevName:     jsr     R1, OutStrI
                .asciz "Device:"
                .even
                emt     6               ; ждём код
                cmpb    R0, #3          ; КТ ?
                bne     1$
                jmp     ContinueDraw    ; просто продолжим с того места, на котором прервали

1$:             cmpb    R0, #12         ; ввод ?
                bne     2$
                movb    CurDev, R0      ; применим текущее устройство, с которого запустились
                br      4$

2$:             cmpb    R0, #'@         ; буква?
                bhis    3$              ; да - переход
                                        ; нет - установим устройство по его номеру
                jmp     GetDriveName    ; запрос номера рабочего устройства
                                        ; Выход: R0 - номер устройства

3$:             bic     #177600, R0     ; установим устройство по его имени
                emt     16
                sub     #'A, R0
4$:             jmp     SetDriveName    ; установка рабочего устройства и формирование его символьного имени
                                        ; Вход: R0 - номер устройства
; End of function GetDevName


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Подсчёт КС блока - буфера и перезапись
; по запросу "Replace?" при несовпадении.

Replace$:       mov     R0, -(SP)
                mov     R5, -(SP)
                mov     BUFFER, R5      ; адрес начала буфера
                mov     #1000, R4
                call    @#116622
                cmp     R0, KS          ; контрольная сумма блока, находящегося в буфере
                beq     1$
                call    ReplaceFN
1$:             mov     (SP)+, R5
                mov     (SP)+, BLK
                return
; End of function Replace$


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


ReplaceFN:      emt     26
                mov     R5, -(SP)
                mov     R1, -(SP)
                mov     R2, -(SP)
                call    InitCursorPos
                jsr     R1, OutStrI
                .asciz "Replace ?"
                .even
                call    GetConfirm
                cmpb    R1, #'N
                beq     1$
                mov     #-400, R1
                call    RWBlkErrHandl   ; Чтение/запись блока с обработкой ошибок
                call    OFF             ; останов двигателя, подсчёт КС и вывод в служебную строку номера блока
                                        ; находящегося в буфере
1$:             mov     (SP)+, R2
                mov     (SP)+, R1
                mov     (SP)+, R5
                emt     24
; End of function ReplaceFN


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; очистка командной строки

ClearCmdLn:     call    CursorSwitch    ; Переключение режима индикации курсора
                mov     R1, -(SP)
                mov     #75400, R1
1$:             clr     (R1)+
                tst     R1
                bpl     1$
                mov     R2, -(SP)
                call    OutStrMacro11
                mov     (SP)+, R2
                mov     (SP)+, R1

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Переключение режима индикации курсора

CursorSwitch:   mov     R0, -(SP)
                mov     #232, R0        ; Переключение режима индикации курсора
                emt     16
                mov     (SP)+, R0
                return
; End of function CursorSwitch


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


OutStrMacro11:  mov     #30, R1
                mov     #27, R2
                emt     24
                jsr     R1, OutStrI
                .asciz " Macro-11: "<32><25>
                .even
                return
; End of function OutStrMacro11


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Чтение/запись блока с обработкой ошибок

RWBlkErrHandl:  jsr     R4, @#110346
                mov     R5, -(SP)
                mov     R1, -(SP)
1$:             clrb    @#ERRFDD
                mov     (SP), R1
                mov     BLK, R0
                mov     BUFFER, R2      ; адрес начала буфера
                call    INOUT
                bcc     3$
                mov     #-1, D$TRKTAB(R3)
                mov     #-1, D$TRKTAB+2(R3)
                cmpb    @#ERRFDD, #7
                beq     2$
                jsr     R1, OutStrI
                .asciz ", [I]-Ignore "
                .even

                call    Input$LC        ; Приём кода с клавиатуры с ожиданием
                                        ; и приведение символов к Лат.Загл.
                cmpb    R0, #'I
                bne     1$
2$:             call    ClearCmdLn
3$:             tst     (SP)+
                mov     (SP)+, R5
                jsr     R4, @#110362
                return
; End of function RWBlkErrHandl


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Чтение/запись блока

RWBlock:        tstb    OSType          ; флаг: 0 - АНДОС !0 - МКДОС
                beq     1$
                mov     DRVTAB, R3      ; Рабочая  область  драйвера  НГМД в МКДОС
                mov     @#MK$DRIVER, -(SP) ; Адрес входа "чтение/запись блока" драйвера НГМД в МКДОС
                br      2$

1$:             mov     #AN$DRVTAB, R3  ; Рабочая  область  драйвера  НГМД в АНДОС
                mov     @#AN$DRIVER, -(SP) ; Адрес входа "чтение/запись блока" драйвера НГМД в АНДОС
2$:             movb    DEV, D$UNIT(R3)
                call    @(SP)+
                bcc     4$
                call    InitCursorPos
                jsr     R1, OutStrI
                .asciz <231>"Ошибка #"
                .even

                movb    @#ERRFDD, R0
                add     #'0, R0
                cmpb    R0, #'8
                blo     3$
                movb    #'1, R0
                emt     16
                movb    @#ERRFDD, R0
                add     #50, R0
3$:             emt     16
                sec
4$:             return
; End of function RWBlock


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; останов двигателя, подсчёт КС и вывод в служебную строку номера блока
; находящегося в буфере

FinishRWOp:     jsr     R4, @#110346
                mov     R5, -(SP)
                clr     @DRVTAB
                tstb    OSType          ; флаг: 0 - АНДОС !0 - МКДОС
                bne     1$
                clr     @#AN$DRVTAB

1$:             clr     @#177130
                mov     BUFFER, R5      ; адрес начала буфера
                mov     #1000, R4
                call    @#116622
                mov     R0, KS          ; контрольная сумма блока, находящегося в буфере
                call    OutBlkNum$SL    ; Вывод в служебную строку номера блока в буфере
                mov     (SP)+, R5
                jsr     R4, @#110362
                return
; End of function FinishRWOp


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Вход: R3 - адрес буфера ввода

InputString:    mov     R3, R1
loc_11350:      call    EMT6R
sub_11354:
2$:             cmpb    R0, #40
                bhis    5$
                cmpb    R0, #12
                beq     8$
                cmpb    R0, #10
                beq     4$
                cmpb    R0, #31
                bne     3$
                movb    (R1), R0
                cmpb    R0, #12
                beq     loc_11350
                br      2$

3$:             cmpb    R0, #30
                bne     loc_11350
4$:             movb    #30, R0
                cmp     R1, R3
                beq     7$
                dec     R1
                br      6$

5$:             movb    R0, (R1)+
                call    SetSafeChr       ; Замена непечатных символов на точку
6$:             emt     16
7$:             br      loc_11350

8$:             movb    R0, (R1)
                return
; End of function InputString


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Ввод числа с клавиатуры, в понимаемых системах счисления
; Вход:  R0 - первый код нажатой клавиши
; Выход: R5 - число

InputNumber1:   mov     #326, R1
                mov     R1, R3
                jmp     jmp_11500
; End of function InputNumber1


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Ввод числа с клавиатуры, в понимаемых системах счисления
; Выход: R5 - число

InputNumber:    mov     #326, R3
                mov     R3, R1
loc_11476:      emt     6
jmp_11500:      bic     #177600, R0
                cmpb    R0, #'.
                bhis    5$
                cmpb    R0, #12
                beq     8$
                cmpb    R0, #10
                beq     4$
                cmpb    R0, #31
                bne     3$
                movb    (R1), R0
                cmpb    R0, #'.
                bhis    jmp_11500
                br      loc_11476

3$:             cmpb    R0, #30
                bne     loc_11476
4$:             movb    #30, R0
                cmp     R1, R3
                beq     7$
                dec     R1
                br      6$

5$:             movb    R0, (R1)+
6$:             emt     16
7$:             br      loc_11476

8$:             movb    R0, (R1)
                cmp     R3, R1
                bne     9$
                clr     R5
                return

9$:             movb    -(R1), R0

; Парсинг числа из строки символов.
; Вход: R3 - адрес буфера строки
;       R0 - суффикс, по которому определяется система счисления
;       . - десятичное число, B - двоичное, иначе восьмеричное
; Выход: R5 - число

StrToNumber:    cmpb    R0, #'.
                beq     13$
                cmpb    R0, #'B
                beq     15$
10$:            clr     R5
11$:            cmpb    (R3), #'0
                blo     12$
                movb    (R3)+, R0
                cmpb    R0, #'7
                bhi     10$
                sub     #'0, R0
                bmi     10$
                asl     R5
                asl     R5
                asl     R5
                add     R0, R5
                br      11$

12$:            return

13$:            clr     R5
                clr     R2
14$:            movb    (R3)+, R0
                cmpb    R0, #'.
                beq     12$
                sub     #'0, R0
                bmi     13$
                mov     R5, R2
                asl     R5
                asl     R2
                asl     R2
                asl     R2
                add     R2, R5
                add     R0, R5
                br      14$

15$:            clr     R5
16$:            movb    (R3)+, R0
                cmpb    R0, #'B
                beq     12$
                sub     #'0, R0
                bmi     15$
                asl     R5
                add     R0, R5
                br      16$
; End of function InputNumber


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Вывод текста в служебную строку
; Вход: R2 - строка
;       R1 - координата

OSSL$:          inc     R1
                emt     22

OutStr$SL:      movb    (R2)+, R0
                bne     OSSL$
                return
; End of function OutStr$SL


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Установка курсора в начало командной строки

InitCursorPos:  mov     #26, R2
                clr     R1
                emt     24
                return
; End of function InitCursorPos


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; быстрый вывод символа на экран

IOTTrp:         bitb    R0, #140
                bne     1$
                emt     16
                rti

1$:             mov     R1, -(SP)
                mov     R0, -(SP)
                mov     R3, -(SP)
                mov     @#160, R1
                bic     #177400, R0
                cmp     #200, R0
                bgt     2$
                sub     #40, R0
2$:             cmp     #20, R0
                ble     3$
                add     #11, R0
3$:             mov     R0, R3
                asl     R3
                asl     R3
                add     R0, R3
                asl     R3
                add     #111576, R3
                mov     #5, R0
4$:             movb    (R3)+, (R1)
                movb    (R3)+, 100(R1)
                add     #200, R1
                sob     R0, 4$
                inc     @#160
                mov     @#160, R0
                bit     #77, R0
                bne     5$
                add     #1100, @#160
5$:             mov     (SP)+, R3
                mov     (SP)+, R0
                mov     (SP)+, R1
                rti
; End of function IOTTrp


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


V60Trp:         jsr     R4, @#110346
                mov     R5, -(SP)
                call    @#102044
                cmpb    R0, #20
                blos    1$
                jmp     @#101304

1$:             cmpb    R0, #17
                bne     2$
                jmp     @#101234

2$:             cmpb    R0, #16
                bne     3$
                jmp     @#101224

3$:             call    @#102124
                movb    #1, @#105
                jmp     @#101322
; End of function V60Trp


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


V274Trp:        jsr     R4, @#110346
                mov     R5, -(SP)
                call    @#102044
                bisb    #200, R0
                cmpb    R0, #277
                blos    1$
                jmp     @#101406

1$:             jmp     @#101602
; End of function V274Trp


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


InitVec:        mov     @#122, -(SP)
                mov     @#124, -(SP)
                mov     #40, R1
                call    @#100176        ; emt 14 без очистки области 0..40
                mov     (SP)+, @#124
                mov     (SP)+, @#122
                jsr     R1, OutStrI
                .byte 232, 233, 224, 236, 221, 233, 0
                .even

                mov     PC, @#20
                add     #IOTTrp-.+2, @#20
                mov     PC, @#4
                add     #Start$-.+2, @#4
                .addr   R1, V60Trp
                mov     R1, @#60
                add     #V274Trp-V60Trp, R1
                mov     R1, @#274
                return
; End of function InitVec


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Передача управления функции пользователя

CallUser:       tstb    USRFLG
                beq     1$
                jmp     jmp_2356

1$:             call    InitCursorPos
                mov     R5, -(SP)       ; текущий адрес, на котором стоит курсор
                call    @USR
                br      4$
; End of function CallUser


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Загрузка функции пользователя

LoadUser:       mov     R5, -(SP)
                call    InitCursorPos
                jsr     R1, OutStrI
                .asciz "Loading User Function?"
                .even

                call    GetConfirm
                cmpb    R1, #'N
                bne     1$
                jmp     jmp_2070

1$:             jsr     R1, OutStrI
                .asciz <32><25><231>"File's Name:"
                .even

                mov     #320, R3
                mov     #3, (R3)+
                mov     USR, (R3)+
                clr     (R3)+
                call    STROKA
2$:             cmp     R1, #346
                bhis    3$
                movb    #40, (R1)+
                br      2$

3$:             call    @#100602        ; загрузка файла
                clrb    USRFLG
                tstb    @#321
                beq     4$
                incb    USRFLG

4$:             cmp     @#177664, #1330
                beq     5$
                call    InitVec
                call    CursorSwitch    ; Переключение режима индикации курсора
5$:             call    ClearCmdLn
                mov     (SP)+, R5
                jmp     DrawDump
; End of function LoadUser


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Переход к файлу (АНДОС, МКДОС)

GotoFile:       call    InitCursorPos
                mov     R5, -(SP)
                tstb    OSType          ; флаг: 0 - АНДОС !0 - МКДОС
                beq     2$
                tst     MK$SCR          ; флаг перехвата вывода сообщений в МКДОС
                beq     4$
                mov     #320, @#MK$NAM  ; Адрес блока параметров EMT36 в МКДОС
                call    EnterFileName   ; Запрос и ввод имени файла
                cmp     R3, R1
                bne     1$
                jmp     jmp_13322

1$:             mov     @#MK$BLK, R3    ; Адрес блока параметров диска в МКДОС
                call    @MK$INIDRV      ; Инициализация драйвера дисковода в МКДОС
                movb    DEV, D$UNIT(R3)
                call    @MK$RDDIR       ; Чтение каталога в буфер в МКДОС
                bcs     3$
                cmp     400(R3), #123456
                bne     3$
                call    @MK$DIRFIN      ; Поиск файла в каталоге в МКДОС
                bcs     7$
                mov     24(R3), OFSADR  ; адрес загрузки файла
                mov     20(R3), R5      ; номер блока файла
                br      11$

2$:             call    EnterFileName   ; Запрос и ввод имени файла
                cmp     R1, R3
                beq     5$
                mov     #320, R1
                clr     (R1)
                emt     36
                movb    DEV, R0
                inc     R0
                mov     #AN$DEVICE, R1  ; Текущее устройство в АНДОС
                movb    (R1), AN$TD$GF  ; сохраним
                movb    R0, (R1)+
                movb    R0, (R1)
                call    @AN$INIDRV      ; Инициализация работы с диском в АНДОС
                bcc     6$
3$:             jsr     R1, OutStrI
                .asciz <32><25>"Non DOS Disk"<231>
                .even
4$:             br      8$

5$:             jsr     R1, OutStrI
                .asciz <32><25>"Номер кластера ="<231>
                .even
                call    InputNumber     ; Ввод числа с клавиатуры, в понимаемых системах счисления
                                        ; Выход: R5 - число
                br      10$

6$:             mov     #AN$NAMBUF, R1  ; Буфер имени в АНДОС
                call    @AN$DIRFIN      ; Поиск файла в каталоге в АНДОС
                movb    (PC)+,@(PC)+    ; восстановим тек. устройство в АНДОС
AN$TD$GF:       .word 0, AN$DEVICE
                bcc     9$
7$:             jsr     R1, OutStrI
                .asciz <32><25>"File not found ..."<231>
                .even
8$:             call    Input$LC        ; Приём кода с клавиатуры с ожиданием
                                        ; и приведение символов к Лат.Загл.
                br      jmp_13322

9$:             mov     26.(R2), R5     ; Номер начального кластера
                mov     22.(R2), OFSADR ; Адрес загрузки файла
10$:            inc     R5              ; Кластер -> блок
                asl     R5
                asl     R5
11$:            mov     R5, BLK
                mov     R5, OFSBLK
12$:            mov     BLK, R0
                mov     BUFFER, R2      ; адрес начала буфера
                mov     R2, (SP)
                mov     #400, R1
                call    INOUT
                bcc     jmp_13322
                jsr     R1, OutStrI
                .asciz ", [I]-Ignore"
                .even
                call    Input$LC        ; Приём кода с клавиатуры с ожиданием
                                        ; и приведение символов к Лат.Загл.
                cmpb    R0, #'I
                bne     12$

jmp_13322:      call    FinishRWOp      ; останов двигателя, подсчёт КС и вывод в служебную строку номера блока
                                        ; находящегося в буфере
                mov     (SP)+, R5
                call    ClearCmdLn
                jmp     DrawDump
; End of function GotoFile


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Запрос и ввод имени файла

EnterFileName:  jsr     R1, OutStrI
                .asciz "File's name: "
                .even
                mov     #326, R3
                call    InputString
                cmp     R3, R1
                beq     2$

1$:             movb    #40, (R1)+
                cmp     R1, #326+16.
                blo     1$
2$:             return
; End of function EnterFileName


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Ассемблирование команды
; Вход: R3 - адрес строки команды ассемблера
;       R4 - адрес куда сохраняется ассемблированная команда

Assemble:       clr     MnemVariate
1$:             cmpb    (R3)+, #40
                beq     1$
                dec     R3
                call    Rad50Enc        ; Кодирование трёх символов в код Radix-50
                                        ; Вход: R3 - адрес строки символов
                                        ; Выход: R0 - слово в кодировке Radix-50
                mov     R0, R1          ; первое слово
                call    Rad50Enc        ; Кодирование трёх символов в код Radix-50
                                        ; Вход: R3 - адрес строки символов
                                        ; Выход: R0 - слово в кодировке Radix-50
                mov     #MnemonicTbl, R2    ; таблица мнемоник
                mov     #MnemTblEnd-MnemonicTbl, R5 ;длина таблицы
                asr     R5
                asr     R5              ; количество элементов rad50
2$:             cmp     R1, (R2)+       ; сравниваем первое слово
                beq     4$              ; первое совпало - переход
                tst     (R2)+           ; не совпало - переходим к следующему элементу
                sob     R5, 2$          ; и так всю таблицу
3$:             jmp     Error$          ; ничего в ней не нашли - ошибка

4$:             cmp     R0, (R2)+       ; сравниваем второе слово
                bne     6$              ; не совпало - переход
5$:             sub     #MnemonicTbl+4, R2 ;получим порядковый номер мнемоники в таблице
                asr     R2              ; умноженный на 2
                add     #OpcodeTbl1, R2 ; получим позицию в таблице опкодов
                cmp     R2, #OpcodeTbl2 ; это безоперандная команда?
                bhis    7$              ; нет - переход
                mov     (R2), (R4)+     ; да - вот её опкод
                clc                     ; и всё, выход
                return

6$:             cmp     R2, #MnemRTS+2  ; если мы в списке безоперандных команд
                blo     3$              ; то несовпадение второго слова не допускается
                inc     MnemVariate     ; иначе - отметим факт: первое слово совпало, второе - нет
                br      5$              ; и считаем, что это не ошибка
; ───────────────────────────────────────────────────────────────────────────

7$:             mov     (R2), R2        ; берём код команды
                tst     MnemVariate     ; проверим флаг
                beq     8$              ; мнемоника совпала в точности
                call    sub_14706       ; нет - проверим параметры
8$:             mov     R2, R5
                bic     #37, R2         ; сбросим флаги, получим опкод
                bic     #177760, R5     ; а тут получим код операндов
                asl     R5              ; и умножим его на 2

9$:             cmpb    (R3)+, #40      ; пропустим пробелы после мнемоники
                beq     9$
                dec     R3
                mov     R4, OpcodeAddr  ; адрес опкода в многословных командах
                add     R5, PC
                br      0bransh$        ; 0 - команда ветвления
                br      0sob$           ; 1 - sob
                br      2ops$           ; 2 - двухоперандная команда
                br      2rops$          ; 3 - двухоперандная команда, первый операнд - региср
                br      1ops$           ; 4 - однооперандная команда
                br      1rops$          ; 5 - однооперандная команда, операнд - региср
                br      0emt$           ; 6 - emt/trap
                br      0mark$          ; 7 - mark
                ; 10 - word
                cmpb    (R3), #'@       ; первый символ - собака?
                bne     0emt$           ; нет - значит просто число
                inc     R3              ; иначе это смещение
                call    ParseAriphm     ; Распознание арифметического выражения
                                        ; Вход: R3 - указатель в строке
                                        ; Выход: R0 - результат
                sub     CURADR, R0      ; текущий адрес в файле
                sub     #2, R0          ; формируем смещение
                mov     R0, (R4)+       ; и сохраняем
                clc
                return
; ───────────────────────────────────────────────────────────────────────────
; 0 - команда ветвления
0bransh$:       call    ParseAriphm     ; Распознание арифметического выражения
                                        ; Вход: R3 - указатель в строке
                                        ; Выход: R0 - результат
                sub     CURADR, R0      ; текущий адрес в файле
                sub     #2, R0          ; формируем смещение
                swab    R0              ; смотрим старший байт
                beq     10$             ; 0 - значит положительное число
                comb    R0              ; иначе - отрицательное, или переполнение
                bne     11$             ; не 0 - значит переполнение, ошибка
                sec                     ; устанавливаем С для отрицательного числа,
                                        ; команда не нужна, com итак устанавливает бит С
10$:            ror     R0              ; делим на 2, swab очищает C
                clrb    R0              ; обнуляем ст. байт
                swab    R0              ; возвращаем байты на место
                br      12$             ; и идём сохранять результат

11$:            jmp     Error$
; 5 - однооперандная команда, операнд - региср
1rops$:         call    ParseRegName    ; Распознание имени регистра
                                        ; Вход: R3 - адрес строки
                                        ; Выход: R0 - номер регистра
                br      12$             ; и идём сохранять результат
; 6 - emt/trap
0emt$:          call    ParseNumber     ; Распознание числа
                                        ; Вход: R3 - указатель в строке
                                        ; Выход: R0 - число
                br      12$             ; не проверяем, на переполнение, сразу идём обрабатывать
                                        ; и потому что тут ещё и .word обрабатывается
; 7 - mark
0mark$:         call    ParseNumber     ; Распознание числа
                                        ; Вход: R3 - указатель в строке
                                        ; Выход: R0 - число
                cmp     R0, #100        ; число больше возможного?
                bhis    11$             ; да - ошибка
12$:            add     R2, R0          ; формируем машкод
                mov     R0, (R4)+       ; и сохраняем
                clc
                return
; 1 - sob
0sob$:          call    Parse1Rop       ; Распознание первого операнда-регистра
                call    ParseAriphm     ; Распознание арифметического выражения
                                        ; Вход: R3 - указатель в строке
                                        ; Выход: R0 - результат
                mov     CURADR, R5      ; текущий адрес в файле
                add     #2, R5
                sub     R0, R5
                asr     R5              ; формируем смещение
                cmp     R5, #100        ; если оно больше возможного
                bhis    11$             ; то ошибка
                bis     R5, R2          ; иначе - всё нормально
                mov     R2, (R4)+       ; сохраняем результат
                clc
                return
; 2 - двухоперандная команда
2ops$:          tst     (R4)+           ; сдвигаемся на место первого операнда
                call    ParseOperand    ; распознаём операнд источник
                bne     11$
                swab    R0              ; помещаем код на место
                asr     R0
                asr     R0
                add     R0, R2          ; добавляем в опкод
                cmpb    (R3)+, #',      ; запятая есть?
                bne     11$             ; нет - ошибка
13$:            call    ParseOperand    ; распознаём операнд приёмник
                bne     11$
                add     R2, R0          ; добавляем в опкод
                mov     R0, @OpcodeAddr ; сохраняем результат
                clc
                return
; 3 - двухоперандная команда, первый операнд - региср
2rops$:         call    Parse1Rop       ; Распознание первого операнда-регистра
; 4 - однооперандная команда
1ops$:          tst     (R4)+           ; сдвигаемся на место операнда
                br      13$
; END OF FUNCTION Assemble

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Распознание первого операнда-регистра

Parse1Rop:      call    ParseRegName    ; Распознание имени регистра
                                        ; Вход: R3 - адрес строки
                                        ; Выход: R0 - номер регистра
                swab    R0              ; его на 6 бит влево
                asr     R0
                asr     R0
                add     R0, R2          ; добавим к опкоду
                cmpb    (R3)+, #',      ; следующий символ ','?
                beq     1$              ; да - всё в порядке
                mov     #Error$, (SP)   ; иначе ошибка
1$:             clc
                return
; End of function Parse1Rop


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Распознавание операнда
; Вход: R3 - указатель в строке
;       R4 - адрес, куда сохранять аргументы
; Выход: R0 - код операнда
;        Z - всё впорядке, иначе - ошибка

ParseOperand:   clr     R1              ; тут фоормируется код операнда
                cmpb    (R3), #'@       ; первый символ - собака?
                blo     4$              ; нет, код меньше
                bne     1$              ; нет, код больше
                mov     #10, R1         ; да - значит относительная адресация
                inc     R3              ; пропустим
                cmpb    (R3), #'@       ; второй символ - буква или цифра/знак 
                blo     4$              ; цифра/знак - переход
1$:             call    ParseRegName    ; Распознание имени регистра
                                        ; Вход: R3 - адрес строки
                                        ; Выход: R0 - номер регистра
2$:             bis     R1, R0          ; формируем код
3$:             sez                     ; и выходим
                return

4$:             cmpb    (R3), #'-       ; это минус?
                beq     11$             ; да - переход
                bgt     9$              ; код больше - цифры может быть
                cmpb    (R3), #'#       ; это решётка ?
                beq     6$              ; да - переход
                call    sub_14434       ; Распознавание регистра в скобках
                                        ; Выход: Z=1 - да, Z=0 - нет
                bne     12$             ; тоже нет, тогда ошибка
                bis     #10, R1         ; иначе - относительная адресация
                cmpb    (R3), #'+       ; а в конце есть плюс?
                bne     2$              ; нету - просто относительно регистровая
                cmpb    -5(R3), #'@     ; а собака в начале была?
                beq     5$              ; да
                bic     #10, R1         ; нет - значит не относительная
5$:             inc     R3              ; сдвинем указатель с плюса
                bis     #20, R1         ; код инкрементной операции
                br      2$

6$:             inc     R3              ; пропустим решётку
                bis     #27, R1         ; код непосредственной адресации
                cmpb    (R3), #''       ; дальше апостроф?
                bne     7$              ; нет
                inc     R3              ; да
                movb    (R3)+, R0       ; тогда берём код символа за апострофом
                br      8$

7$:             call    ParseNumber     ; Распознание числа
                                        ; Вход: R3 - указатель в строке
                                        ; Выход: R0 - число
8$:             mov     R0, (R4)+       ; сохраняем результат
                mov     R1, R0          ; и код
                br      3$

9$:             cmpb    (R3), #'0       ; символы '.' и '/' ?
                blo     12$             ; да - ошибка
                cmpb    (R3), #'8       ; символы 70..77
                bhis    12$             ; да - ошибка
                call    ParseAriphm     ; Распознание арифметического выражения
                                        ; Вход: R3 - указатель в строке
                                        ; Выход: R0 - результат
                cmpb    (R3), #'(       ; за выражением скобка?
                bne     10$             ; нет - значит относительная адресация
                mov     R0, (R4)+       ; да - значит индексная, сохраняем индекс
                bis     #60, R1         ; код индексной
                call    sub_14434       ; Распознавание регистра в скобках
                                        ; Выход: Z=1 - да, Z=0 - нет
                cmp     R0, #7          ; регистр == PC ?
                bne     2$              ; нет - всё в порядке
                mov     -(R4), R0       ; иначе скорректируем в относительную адресацию
10$:            bis     #67, R1         ; код относительной
                sub     #2, R0          ; сформируем смещение
                sub     R4, R0
                add     OpcodeAddr, R0
                sub     CURADR, R0      ; текущий адрес в файле
                mov     R0, (R4)+       ; сохраняем результат
                mov     R1, R0          ; и код
                br      3$

11$:            inc     R3              ; пропустим минус
                cmpb    (R3), #'(       ; за минусом скобка?
                bne     12$             ; нет - ошибка. А как же отрицательное число?
                bis     #40, R1         ; да - значит декрементная операция
                call    sub_14434       ; Распознавание регистра в скобках
                                        ; Выход: Z=1 - да, Z=0 - нет
                br      2$              ; и тут не проверяя на ошибки, идём фиксировать результат

12$:            jmp     Error$
; End of function ParseOperand


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Распознавание регистра в скобках
; Выход: Z=1 - да, Z=0 - нет

sub_14434:      cmpb    (R3)+, #'(
                bne     1$
                call    ParseRegName    ; Распознание имени регистра
                                        ; Вход: R3 - адрес строки
                                        ; Выход: R0 - номер регистра
                cmpb    (R3)+, #')
1$:             return
; End of function sub_14434


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Распознание имени регистра
; Вход: R3 - адрес строки
; Выход: R0 - номер регистра

ParseRegName:   movb    (R3)+, R0       ; берём символ
                cmp     R0, #'R         ; R ?
                bne     3$              ; нет
                movb    (R3)+, R0       ; берём следующий символ
                sub     #'0, R0         ; вычитаем '0
                cmp     R0, #'8         ; Ошибка!!! тут надо сравнивать с 8 а не с '8
                blo     2$              ; если меньше, то всё в порядке
1$:             mov     #Error$, (SP)   ; иначе - ошибка
2$:             return

3$:             swab    R0              ; код в старший байт
                clrb    R0
                bisb    (R3)+, R0       ; примем следующий символ
                cmp     R0, #"PS        ; это SP ?
                beq     4$              ; да, его номер 6
                cmp     R0, #"CP        ; это PC ?
                bne     1$              ; нет - ошибка
                mov     #7, R0          ; да - его номер 7
                return

4$:             mov     #6, R0
                return
; End of function ParseRegName

; ───────────────────────────────────────────────────────────────────────────
Error$:         mov     #7, R0
                emt     16
                emt     16
                sec
                return

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Кодирование трёх символов в код Radix-50
; Вход: R3 - адрес строки символов
; Выход: R0 - слово в кодировке Radix-50

Rad50Enc:       mov     R1, -(SP)
                mov     R2, -(SP)
                mov     #3, R2          ; три символа
                clr     R0              ; тут накапливается результат

1$:             movb    (R3)+, R1
                cmp     R1, #'@
                blo     5$
                cmp     R1, #'Z
                bhi     4$
                sub     #'@, R1
                asl     R0
                asl     R0
                asl     R0
                mov     R0, R5
                asl     R0
                asl     R0
                add     R5, R0

2$:             add     R1, R0
3$:             sob     R2, 1$
                inc     R3
4$:             dec     R3
                mov     (SP)+, R2
                mov     (SP)+, R1
                return

5$:             cmp     R1, #'.
                bhis    6$
                cmp     R1, #'$
                bne     4$
                add     #33, R0
                br      3$

6$:             cmp     R1, #'9
                bhi     4$
                sub     #22, R1
                br      2$
; End of function Rad50Enc


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; вход: R2 - опкод с параметрами

sub_14706:      bit     #20, R2         ; этот флаг установлен?
                bne     2$              ; да - переход
                tst     R2              ; нет, а команда байтовая?
                bpl     1$              ; нет - значит ошибка
                cmp     R2, #104000     ; и опкоды выше этого
                bhis    1$              ; тоже ошибка
                mov     #2000, R5       ; а вот это не используется
                xor     R5, R2          ; это наверное MTPI/MFPI MTPD/MFPD
                return

1$:             tst     (SP)+
                jmp     Error$

2$:             bic     #100000, R2     ; значит у опкода снимаем байтовую форму
                return
; End of function sub_14706


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Вывод текущего дизассемблированного кода под курсором

Disassemble:    mov     R3, OpcodeAddr  ; сохраним адрес опкода
                mov     (R3)+, R4       ; получим опкод
                cmp     R4, #400
                bhis    13$
                bit     #100, R4
                bne     6$
                cmpb    R4, #207
                bhis    1$
                cmpb    R4, #200
                bhis    5$
1$:             mov     #OpcodeTbl1, R1
                mov     #/OpcodeTbl2-/OpcodeTbl1, R2
2$:             cmp     R4, (R1)+
                beq     4$
                sob     R2, 2$

jmp_15026:      mov     #MnemWORD, R1
                call    DecodeMnemonic  ; Декодирование мнемоники
                                        ; Вход: R1 - адрес двух слов мнемоники в кодировке Radix-50
                jmp     OutNumOct$FNS   ; Вывод восьмеричного числа на экран через IOT с подавлением ведущих нулей
                                        ; Вход: R4 - число

4$:             sub     #OpcodeTbl1+2, R1
                asl     R1
                add     #MnemonicTbl, R1
                jmp     DecodeMnemonic  ; Декодирование мнемоники
                                        ; Вход: R1 - адрес двух слов мнемоники в кодировке Radix-50

5$:             mov     MnemRTS, R5
                call    DecodeR50S      ; Декодирование кода Radix-50 и добавление пробела в конце
                                        ; Вход: R5 - слово в кодировке Radix-50
                jmp     DisAddr0

6$:             tstb    R4
                bmi     8$
                mov     MnemJMP, R5
                call    DecodeR50S      ; Декодирование кода Radix-50 и добавление пробела в конце
                                        ; Вход: R5 - слово в кодировке Radix-50
7$:             bic     #177700, R4
                jmp     jmp_15132

8$:             mov     #MnemSWAB, R1
                call    DecodeMnemonic  ; Декодирование мнемоники
                                        ; Вход: R1 - адрес двух слов мнемоники в кодировке Radix-50
                br      7$

jmp_15132:      mov     R4, R1
jmp_15134:      bic     #177707, R1
                asr     R1
                asr     R1
                add     R1, PC
                br      DisAddr0        ; адресация 0
                br      DisAddr1        ; адресация 1
                br      DisAddr2        ; адресация 2
                br      DisAddr3        ; адресация 3
                br      DisAddr4        ; адресация 4
                br      DisAddr5        ; адресация 5
                br      DisAddr6        ; адресация 6
                movb    #'@, R0         ; адресация 7
                iot
                ; адресация 6
DisAddr6:       mov     R4, R2
                mov     (R3)+, R4
                bic     #177770, R2
                cmp     R2, #7
                bne     11$
                add     R3, R4
                add     CURADR, R4      ; текущий адрес в файле
                sub     OpcodeAddr, R4
                call    OutNumOct$FNS   ; Вывод восьмеричного числа на экран через IOT с подавлением ведущих нулей
                                        ; Вход: R4 - число
                mov     R2, R4
                return

11$:            call    OutNumOct$FNS   ; Вывод восьмеричного числа на экран через IOT с подавлением ведущих нулей
                                        ; Вход: R4 - число
                mov     R2, R4
                jmp     DisAddr1
; адресация 5
DisAddr5:       movb    #'@, R0
                iot
; адресация 4
DisAddr4:       movb    #'-, R0
                iot
                jmp     DisAddr1
; адресация 3
DisAddr3:       movb    #'@, R0
                iot
; адресация 2
DisAddr2:       bic     #177770, R4
                cmp     R4, #7
                beq     12$
                call    DisAddr1
                movb    #'+, R0
                iot
                return

12$:            movb    #'#, R0
                iot
                mov     (R3)+, R4
                jmp     OutNumOct$FNS   ; Вывод восьмеричного числа на экран через IOT с подавлением ведущих нулей
                                        ; Вход: R4 - число

; опкоды 400..177777
13$:            mov     R4, R2          ; сохраним оригинал опкода
                sxt     MnemVariate     ; и зафиксируем флаг байтовой операции
                bic     #100000, R4     ; а признак байтовой операции сбросим
                mov     #Intrv, R5      ; проверим интервал
14$:            cmp     R4, (R5)+
                bhis    14$
                jmp     @IntrvJmps-Intrv-2(R5)
; End of function Disassemble
; ───────────────────────────────────────────────────────────────────────────
Intrv:          .word 4000
                .word 5000
                .word 6400
                .word 10000
                .word 60000
                .word 100000
IntrvJmps:      .word DisIntrv1
                .word DisIntrv2
                .word DisIntrv3
                .word DisIntrv4
                .word DisIntrv5
                .word DisIntrv6
; ───────────────────────────────────────────────────────────────────────────
; адресация 1
DisAddr1:       movb    #'(, R0
                iot
                call    DisAddr0
                movb    #'), R0
                iot
                return
; ───────────────────────────────────────────────────────────────────────────
; адресация 0
DisAddr0:       bic     #177770, R4
                cmp     R4, #6
                blo     2$
                bhi     1$
                mov     #"PS, R4
                br      3$

1$:             mov     #"CP, R4
                br      3$

2$:             add     #"0R, R4
3$:             swab    R4
                movb    R4, R0
                iot
                swab    R4
                movb    R4, R0
                iot
                return

; ───────────────────────────────────────────────────────────────────────────
;опкоды 400..3777 100400..103777 - ветвления
DisIntrv1:      clrb    R4              ; получим код ветвления
                swab    R4              ; из него сделаем номер, отсчёт начинается с 1
                asl     R4              ; * 4
                asl     R4
                add     #MnemSWAB, R4   ; получим адрес мнемоники
                mov     R4, R1
                tst     MnemVariate     ; проверим, какой интервал ветвлений
                bpl     1$              ; первый
                add     #MnemBPL-MnemSWAB, R1 ; второй
1$:             call    DecodeMnemonic  ; Декодирование мнемоники
                                        ; Вход: R1 - адрес двух слов мнемоники в кодировке Radix-50
                movb    R2, R2          ; теперь получим смещение, расширим знак до слова
                inc     R2
                asl     R2
                add     CURADR, R2      ; текущий адрес в файле
                mov     R2, R4          ; получим адрес перехода
                jmp     OutNumOct$FNS   ; Вывод восьмеричного числа на экран через IOT с подавлением ведущих нулей
                                        ; Вход: R4 - число
; ───────────────────────────────────────────────────────────────────────────
;опкоды 4000..4777 и 104000..104777
DisIntrv2:      tst     MnemVariate     ; это у нас что?
                bmi     3$              ; emt/trap
                cmp     R4, #4700       ; jsr/call
                blo     1$
                mov     #MnemCALL, R1
                call    DecodeMnemonic  ; Декодирование мнемоники
                                        ; Вход: R1 - адрес двух слов мнемоники в кодировке Radix-50
                jmp     jmp_15132

1$:             mov     MnemJSR, R5
jmp_15616:      call    DecodeR50S      ; Декодирование кода Radix-50 и добавление пробела в конце
                                        ; Вход: R5 - слово в кодировке Radix-50
                mov     R4, R1          ; дизассемблируем регистр
                asl     R4
                asl     R4
                swab    R4
                call    DisAddr0
                movb    #',, R0
                iot
                mov     R1, R4
                jmp     jmp_15134
; emt/trap
3$:             bit     #400, R4
                beq     4$
                mov     #MnemTRAP, R1
                br      5$

4$:             mov     #MnemEMT, R1
5$:             call    DecodeMnemonic  ; Декодирование мнемоники
                                        ; Вход: R1 - адрес двух слов мнемоники в кодировке Radix-50
                bic     #177400, R4
                jmp     OutNumOct$FNS   ; Вывод восьмеричного числа на экран через IOT с подавлением ведущих нулей
                                        ; Вход: R4 - число
; ───────────────────────────────────────────────────────────────────────────
; опкоды 5000..6377 и 105000..106377
DisIntrv3:      sub     #5000, R4
                asr     R4
                asr     R4
                asr     R4
                asr     R4
                bic     #3, R4
                add     #MnemCLR, R4

sub_15732:      mov     (R4), R5
                call    Rad50Dec        ; Декодирование кода Radix-50
                                        ; Вход: R5 - слово в кодировке Radix-50
                tst     MnemVariate
                bpl     1$
                movb    #'B, R0
                iot
1$:             movb    #40, R0
                iot
                mov     R2, R4
                jmp     jmp_15132
; End of function sub_15732

; ───────────────────────────────────────────────────────────────────────────
; опкоды 6400..7777 и 106400..107777
DisIntrv4:      bic     #77, R4
                cmp     R4, #6400
                beq     4$
                cmp     R4, #6700
                beq     1$
                mov     R2, R4
                jmp     jmp_15026

1$:             mov     #MnemSXT, R1
                tst     MnemVariate
                bpl     3$
2$:             add     #4, R1
3$:             call    DecodeMnemonic  ; Декодирование мнемоники
                                        ; Вход: R1 - адрес двух слов мнемоники в кодировке Radix-50
                mov     R2, R4
                jmp     jmp_15132

4$:             mov     #MnemMARK, R1
                tst     MnemVariate
                bmi     2$
                call    DecodeMnemonic  ; Декодирование мнемоники
                                        ; Вход: R1 - адрес двух слов мнемоники в кодировке Radix-50
                mov     R2, R4
                bic     #177700, R4
                jmp     OutNumOct$FNS   ; Вывод восьмеричного числа на экран через IOT с подавлением ведущих нулей
                                        ; Вход: R4 - число
; ───────────────────────────────────────────────────────────────────────────
; опкоды 10000..57777 и 110000..157777
DisIntrv5:      mov     R4, -(SP)
                mov     R4, R2
                swab    R2
                asl     R2
                adc     R2
                asl     R2
                adc     R2
                bic     #7777, R4
                asr     R4
                asr     R4
                swab    R4
                add     #MnemMOV-4, R4
                call    sub_15732
                movb    #',, R0
                iot
                mov     (SP)+, R4
                jmp     jmp_15132
; ───────────────────────────────────────────────────────────────────────────
; опкоды 60000..77777 и 160000..177777
DisIntrv6:      cmp     R4, #70000
                blo     3$
                asl     R4
                asr     MnemVariate
                ror     R4
                bic     #777, R4
                cmp     R4, #77000
                beq     2$
                cmp     R4, #74000
                beq     1$
                mov     R2, R4
                jmp     jmp_15026

1$:             mov     R2, R4
                mov     MnemXOR, R5
                jmp     jmp_15616

2$:             mov     MnemSOB, R5
                call    DecodeR50S      ; Декодирование кода Radix-50 и добавление пробела в конце
                                        ; Вход: R5 - слово в кодировке Radix-50
                mov     R2, R4
                asl     R4
                asl     R4
                swab    R4
                call    DisAddr0
                movb    #',, R0
                iot
                mov     R2, R4
                bic     #177700, R4
                dec     R4
                asl     R4
                sub     CURADR, R4      ; текущий адрес в файле
                neg     R4
                jmp     OutNumOct$FNS   ; Вывод восьмеричного числа на экран через IOT с подавлением ведущих нулей
                                        ; Вход: R4 - число

3$:             tst     MnemVariate
                bpl     4$
                clr     MnemVariate
                add     #10000, R4
4$:             jmp     DisIntrv5

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Декодирование мнемоники
; Вход: R1 - адрес двух слов мнемоники в кодировке Radix-50

DecodeMnemonic: mov     (R1)+, R5
                call    Rad50Dec        ; Декодирование кода Radix-50
                                        ; Вход: R5 - слово в кодировке Radix-50
                mov     (R1)+, R5
; Декодирование кода Radix-50 и добавление пробела в конце
; Вход: R5 - слово в кодировке Radix-50
DecodeR50S:     call    Rad50Dec        ; Декодирование кода Radix-50
                                        ; Вход: R5 - слово в кодировке Radix-50
                movb    #40, R0
                iot
                return
; End of function DecodeR50S
; End of function DecodeMnemonic


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Декодирование кода Radix-50
; Вход: R5 - слово в кодировке Radix-50

Rad50Dec:       mov     R1, -(SP)
                mov     R2, -(SP)
                mov     R3, -(SP)
                mov     #R50Const, R1
                mov     #3, R2          ; 3 символа
1$:             clr     R3              ; тут формируется код символа
2$:             cmp     R5, (R1)        ; делим
                blo     3$
                sub     (R1), R5
                inc     R3
                br      2$

3$:             tst     R3              ; смотрим, что получилось
                beq     7$              ; 0 - пробел, игнорируем
                cmp     R3, #33         ; это буква ?
                blo     5$              ; да - переход
                beq     4$              ; если знак $ - переход
                add     #22, R3         ; иначе - . / и цифры
                br      6$

4$:             mov     #'$, R3         ; формируем солнышко
                br      6$

5$:             add     #'@, R3         ; формируем код буквы
6$:             movb    R3, R0
                iot                     ; и выводим на экран
7$:             tst     (R1)+
                sob     R2, 1$
                mov     (SP)+, R3
                mov     (SP)+, R2
                mov     (SP)+, R1
                return
; End of function Rad50Dec

; ───────────────────────────────────────────────────────────────────────────
R50Const:       .word 3100
                .word 50
                .word 1

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Распознание арифметического выражения
; Вход: R3 - указатель в строке
; Выход: R0 - результат

ParseAriphm:    dec     R3
                clr     -(SP)           ; тут формируется результат
1$:             inc     R3              ; переходим к следующему символу
2$:             call    ParseNumber     ; Распознание числа
                                        ; Вход: R3 - указатель в строке
                                        ; Выход: R0 - число
                add     R0, (SP)        ; добавляем к результату
                cmpb    (R3), #'-       ; за числом есть знак - ?
                beq     2$              ; да - пойдём распознаем ещё число
                cmpb    (R3), #'+       ; есть знак + ?
                beq     1$              ; да - пропустим его и пойдём распознаем ещё число
                mov     (SP)+, R0       ; возвращаем результат
                return
; End of function ParseAriphm


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Распознание числа
; Вход: R3 - указатель в строке
; Выход: R0 - число

ParseNumber:    mov     R2, -(SP)
                mov     R4, -(SP)
                mov     R1, -(SP)
                mov     R3, R1          ; указатель в строке
                bic     (PC), -(SP)     ; хитрая хрень вместо банального clr -(sp)
                cmpb    (R1), #'-       ; минус?
                bne     1$
                inc     (SP)            ; да - фиксируем
                inc     R1
                inc     R3

1$:             cmpb    (R1), #'.       ; точка?
                bne     2$              ; нет
                mov     CURADR, R0      ;да - текущий адрес в файле
                inc     R3
                br      4$

2$:             movb    (R1)+, R0       ; берём символ
                cmpb    R0, #'0         ; если это не цифра
                blo     3$              ; то число закончилось
                cmpb    R0, #'9         ; и это суффикс
                bhi     3$
                br      2$

3$:             call    StrToNumber     ; Парсинг числа из строки символов.
                                        ; Вход: R3 - адрес буфера строки
                                        ;       R0 - суффикс, по которому определяется система счисления
                                        ;       . - десятичное число, B - двоичное, иначе восьмеричное
                                        ; Выход: R5 - число
                mov     R5, R0          ; распознанное число
                mov     R1, R3          ; текущий указатель в строке
                dec     R3
4$:             asr     (SP)+           ; число было отрицательное?
                bcc     5$              ; нет
                neg     R0              ; да - меняем знак
5$:             mov     (SP)+, R1
                mov     (SP)+, R4
                mov     (SP)+, R2
                return
; End of function ParseNumber

; ───────────────────────────────────────────────────────────────────────────
; не используются
                asr     R0
                asr     R0
                asr     R0
                asr     R0
                asr     R0
                asr     R0
                return
; ───────────────────────────────────────────────────────────────────────────
                asl     R0
                asl     R0
                asl     R0
                asl     R0
                asl     R0
                asl     R0
                return

MnemonicTbl:    .rad50  "HAL  T"
                .rad50  "WAI  T"
                .rad50  "RTI   "
                .rad50  "BPT   "
                .rad50  "IOT   "
                .rad50  "RES ET"
                .rad50  "RTT   "
                .rad50  "RET   "
                .rad50  "NOP   "
                .rad50  "CLC   "
                .rad50  "CLV   "
                .rad50  "CLZ   "
                .rad50  "CLN   "
                .rad50  "CCC   "
                .rad50  "SEC   "
                .rad50  "SEV   "
                .rad50  "SEZ   "
                .rad50  "SEN   "
                .rad50  "SCC   "
MnemRTS:        .rad50  "RTS   "
MnemJMP:        .rad50  "JMP   "
MnemSWAB:       .rad50  "SWA  B"
                .rad50  " BR   "
                .rad50  "BNE   "
                .rad50  "BEQ   "
                .rad50  "BGE   "
                .rad50  "BLT   "
                .rad50  "BGT   "
                .rad50  "BLE   "
MnemJSR:        .rad50  "JSR   "
MnemCALL:       .rad50  "CAL  L"
MnemCLR:        .rad50  "CLR  B"
                .rad50  "COM  B"
                .rad50  "INC  B"
                .rad50  "DEC  B"
                .rad50  "NEG  B"
                .rad50  "ADC  B"
                .rad50  "SBC  B"
                .rad50  "TST  B"
                .rad50  "ROR  B"
                .rad50  "ROL  B"
                .rad50  "ASR  B"
                .rad50  "ASL  B"
MnemMARK:       .rad50  "MAR  K"
                .rad50  "MTP  S"
MnemSXT:        .rad50  "SXT   "
                .rad50  "MFP  S"
MnemMOV:        .rad50  "MOV  B"
                .rad50  "CMP  B"
                .rad50  "BIT  B"
                .rad50  "BIC  B"
                .rad50  "BIS  B"
                .rad50  "ADD   "
                .rad50  "SUB   "
MnemXOR:        .rad50  "XOR   "
MnemSOB:        .rad50  "SOB   "
MnemBPL:        .rad50  "BPL   "
                .rad50  "BMI   "
                .rad50  "BHI   "
                .rad50  "BLO  S"
                .rad50  "BVC   "
                .rad50  "BVS   "
                .rad50  "BHI  S"
                .rad50  "BLO   "
                .rad50  "BCC   "
                .rad50  "BCS   "
MnemEMT:        .rad50  "EMT   "
MnemTRAP:       .rad50  "TRA  P"
MnemWORD:       .rad50  ".WO RD"
MnemTblEnd:
; таблица опкодов безоперандных команд
OpcodeTbl1:     .word 0
                .word 1
                .word 2
                .word 3
                .word 4
                .word 5
                .word 6
                .word 207
                .word 240
                .word 241
                .word 242
                .word 244
                .word 250
                .word 257
                .word 261
                .word 262
                .word 264
                .word 270
                .word 277
; таблица опкодов остальных команд,
; тут такие флаги:
; 20 - если установлен, то при не совпадении второго слова мнемоники снимается байтовая форма
;       если байтовой формы не было, то ошибка, и ещё кое что
; 0..17 - код:
; 0 - команда ветвления
; 1 - sob
; 2 - двухоперандная команда
; 3 - двухоперандная команда, первый операнд - региср
; 4 - однооперандная команда
; 5 - однооперандная команда, операнд - региср
; 6 - emt/trap
; 7 - mark
; 10 - word
OpcodeTbl2:     .word 200+5
                .word 100+4
                .word 300+4
                .word 400
                .word 1000
                .word 1400
                .word 2000
                .word 2400
                .word 3000
                .word 3400
                .word 4000+3
                .word 4700+4
                .word 105000+20+4
                .word 105100+20+4
                .word 105200+20+4
                .word 105300+20+4
                .word 105400+20+4
                .word 105500+20+4
                .word 105600+20+4
                .word 105700+20+4
                .word 106000+20+4
                .word 106100+20+4
                .word 106200+20+4
                .word 106300+20+4
                .word 6400+7
                .word 106400+4
                .word 6700+4
                .word 106700+4
                .word 110000+20+2
                .word 120000+20+2
                .word 130000+20+2
                .word 140000+20+2
                .word 150000+20+2
                .word  60000+20+2
                .word 160000+20+2
                .word 74000+3
                .word 77000+1
                .word 100000
                .word 100400
                .word 101000
                .word 101400
                .word 102000
                .word 102400
                .word 103000
                .word 103400
                .word 103000
                .word 103400
                .word 104000+6
                .word 104400+6
                .word 10

MnemVariate:    .word 0                 ; Для ассемблирования: флаг вариативности мнемоники (байтовая словная форма)
                                        ; 0 - байтовая форма, !0 - словная
                                        ; Для дизассемблирования наоборот - 0 - словная, !0 - байтовая

OpcodeAddr:     .word 0                 ; Для ассемблирования: адрес опкода в 2-х, 3-х словных командах
                                        ; Для дизассемблирования: адрес любого опкода

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; печать копии экрана

Print$:         jsr     R4, @#110346
                mov     R5, -(SP)
                mov     @#4, -(SP)
                mov     @#177660, -(SP)
                mov     #100, @#177660  ; запрещаем прерывания от клавиатуры
                mov     SP, TmpSP
                .addr   R0, TrapTo4
                mov     R0, @#4
                clr     @#46            ; Режим ИСУ (0 - выкл., 377 - вкл.)
                                        ; Режим БЛР (0 - выкл., 377 - вкл.)
                clrb    TmpChr
                tstb    @#56            ; Курсор погашен?
                bne     1$              ; да - переход
                mov     #232, R0        ; нет - погасим курсор
                movb    R0, TmpChr
                emt     16
1$:             mov     #400, R0
2$:             bit     R0, @#177714
                bne     3$
                cmp     #400, R0
                bne     1$
                mov     #40000, R0
                br      2$

3$:             mov     R0, PrnStrobe
                mov     #42000, word_20240
                movb    #27, byte_20244

4$:             movb    #11, R0
                call    PrnChr
                movb    #100, byte_20243

5$:             call    sub_17772
                inc     word_20240
                decb    byte_20243
                bne     5$
                call    NewLine
                add     #1100, word_20240
                decb    byte_20244
                bne     4$
                br      TrapTo4
; End of function Print$


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; переход на новую строку

NewLine:        mov     #15, R0
                call    PrnChr
                mov     #12, R0
                br      PrnChr
; End of function NewLine


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Распознание кода символа на экране

sub_17772:      mov     #112276, R1
                mov     #40, R2
                mov     #300, R3

1$:             mov     word_20240, R0
                mov     R1, R4
                mov     #12, R5

2$:             cmpb    (R4)+, (R0)
                beq     3$
                inc     R2
                add     #12, R1
                sob     R3, 1$
                mov     #40, R2
                br      4$

3$:             add     #100, R0
                sob     R5, 2$

4$:             mov     #17, R0
                tstb    R2
                bpl     6$
                add     #40, R2
                bit     #100, R2
                bne     5$
                bic     #177400, R2
                add     #PrnTranscode-PC$1-240, R2
                add     PC, R2
PC$1:           movb    (R2), R2
                bpl     6$

5$:             mov     #16, R0
6$:             call    PrnChr
                mov     R2, R0
; End of function sub_17772

; ───────────────────────────────────────────────────────────────────────────
; отправка символа на принтер

PrnChr:         comb    R0
                bitb    #177, R0
                bne     1$
                bisb    #40, R0
1$:             comb    R0
                bis     #177400, R0
2$:             bit     PrnStrobe, @#177714
                beq     2$
                mov     R0, @#177714
3$:             bit     PrnStrobe, @#177714
                bne     3$
                movb    R0, @#177714
                return
; End of function PrnChr

; ───────────────────────────────────────────────────────────────────────────

TrapTo4:        mov     TmpSP, SP
                tst     @#177662
                mov     (SP)+, @#177660
                mov     (SP)+, @#4
                movb    TmpChr, R0
                emt     16
                mov     (SP)+, R5
                jsr     R4, @#110362
                return

; ───────────────────────────────────────────────────────────────────────────
PrnStrobe:      .word 400
TmpSP:          .word 0
word_20240:     .word 0
TmpChr:         .byte 0
byte_20243:     .byte 0
byte_20244:     .byte 0

PrnTranscode:   .byte 360,  53, 137,  53, 174,  53,  53,  75
                .byte  75, 137,  53,  53,  55, 174,  53, 174
                .byte  53,  74,  43, 174, 137,  55, 174, 174
                .byte 137,  53,  75,  55,  75, 174,  76,  43
                .even

StrHelp:        .asciz <10>"┌═════════════════════════════════════════┐"
                .asciz <10>"║"<1>"(C)"<1>"MKT"<1>"corp."<2>"DESS"<1>"v2.9$"<3>"12-May-97г."<1>"║"
                .asciz <10>"║"<2>"Михаил"<1>"Королев,"<2>"тел:"<1>"(095)"<1>"499-41-06"<2>"║"
                .asciz <10>"└═════════════════════════════════════════┘"
                .asciz <2>"ВС"<13>"-"<1>"префикс"
                .asciz <1>"+,-,="<11>"-"<1>"плюс/минус/присвоить"<1>"число"<1>"к"<1>"содержимому"<1>"ячейки"
                .asciz <1>"ВВОД"<12>"-"<1>"курсор"<1>"в"<1>"поле"<1>"символов"
                .asciz <1>"ИСУ"<13>"-"<1>"печать"<1>"копии"<1>"экрана"<1>"(из"<1>"любого"<1>"режима)"
                .asciz <1>"[=]"<13>"-"<1>"ввод"<1>"байта"<1>"(только"<1>"в"<1>"поле"<1>"символов)"
                .asciz <1>"[↑],[↓]"<7>"-"<1>"вверх,вниз"<1>"на"<1>"400"<1>"байт"
                .asciz <1>"[СБР]"<11>"-"<1>"поставить"<1>"метку"
                .asciz <1>"[ШАГ]"<11>"-"<1>"поменять"<1>"курсор"<1>"с"<1>"меткой"
                .asciz <1>"[A]ddress"<5>"-"<1>"переход"<1>"к"<1>"адресу"
                .asciz <1>"[@]"<13>"-"<1>"переход"<1>"по"<1>"содержимому"<1>"ячейки"<1>"(37)"
                .asciz <1>"[_]"<13>"-"<1>"переход"<1>"по"<1>"смещению"<1>"в"<1>"ячейке"<1>"(67)"
                .asciz <1>"[O]ffset"<6>"-"<1>"задание"<1>"смещения"
                .asciz <1>"[B]lock"<7>"-"<1>"выбор"<1>"блока"
                .asciz <1>"[D]evice"<6>"-"<1>"выбор"<1>"устройства,"<1>"КТ-отмена"
                .asciz <1>"[F]iles"<7>"-"<1>"переход"<1>"по"<1>"имени"<1>"файла"<1>"(ANDOS,MKDOS)"
                .asciz <1>"[E]xit"<10>"-"<1>"выход"<2>"из"<1>"программы"
                .asciz <1>"[Q]uit"<10>"-"<1>"аварийный"<1>"выход"<1>"из"<1>"программы"
                .asciz <1>"[H]elp"<10>"-"<1>"эта"<1>"инструкция"
                .asciz ""
                .asciz "Continue"<1>"<Y>?"<176>
                .asciz <1>"[R]eplace"<5>"-"<1>"записать"<1>"блок"<1>"на"<1>"диск"
                .asciz <1>"[Z]"<1>"Saved"<1>"in"<2>"-"<1>"скопировать"<1>"блок"<1>"на:"<1>"[D]evice,"<1>"[B]lock"
                .asciz <1>"[C]ode"<10>"-"<1>"ввести"<1>"мнемонику"
                .asciz <1>"[T]race"<7>"-"<1>"шаг"<1>"на"<1>"одну"<1>"машинную"<1>"команду"
                .asciz <1>"[M]odel"<7>"-"<1>"задать"<1>"модель"<1>"поиска:"
                .asciz <21>"[W]ord"<2>"-"<1>"слова,"<2>"[B]yte"<1>"-"<1>"байта"
                .asciz <21>"[A]scii"<1>"-"<1>"текста,"<1>"[M]acro"<1>"-"<1>"мнемоники"
                .asciz <1>"[S]earch"<6>"-"<1>"поиск"<1>"модели,"<1>"КТ"<1>"-"<1>"остановить"
                .asciz <1>"[I]nformation"<1>"-"<1>"вид"<1>"дополнительной"<1>"информации:"
                .asciz <21>"[B]inary"<2>"-"<1>"двоичная"<0><21>"[D]ecimal"<1>"-"<1>"десятичная"
                .asciz <21>"[O]ctal"<3>"-"<1>"восьмиричная"
                .asciz <1>"[U]ser"<10>"-"<1>"передача"<1>"управление"<1>"функции"<1>"пользователя"
                .asciz <1>"[СУ/U]"<10>"-"<1>"загрузка"<1>"функции"<1>"пользователя"
                .asciz ""
                .asciz <1>"Все"<1>"вводимые"<1>"числа"<1>"-"<1>"восьмиричные"<1>"по"<1>"умолчанию,"<1>"если"<1>"в"<1>"конце"
                .asciz "стоит"<1>"точка"<1>"'.'"<1>"-"<1>"десятичное,"<1>"если"<1>"'B'"<1>"-"<1>"двоичное."
                .asciz ""
                .asciz <1>"Огромное"<1>"спасибо:"<3>"фирме"<1>"DEC,"<1>"з-ду"<1>\"Экситон",\<1>"БК0011м,"
                .asciz "Д.Климову,"<1>"В.Коренкову,"<1>"А.Надежину,"<1>"И.Юдину,"<1>"фирме"<1>"ALTec"
                .asciz <176><176>
                .byte 200

                .even

                .END
